{************************************************}
{                                                }
{   Data access components                       }
{                                                }
{   Turbo Pascal 7                               }
{   FreePacal                                    }
{   Delphi 2 - 5                                 }
{   Virtual Pascal 2.1                           }
{                                                }
{   Copyright (c) 1995-2000 by Alexs             }
{                                                }
{************************************************}

{$IFDEF VER70}
{$O+}
{$ENDIF}

{$I Define.inc}

unit DataCtrl;

interface

uses Views, Drivers, Objects, DAE, DBFTable, Ext_Type, Ext_Math, Ext_Dos,
     Clases, Register;


const
  DBComponents = [ctDataSourse, ctDBSourse];

const
  NameDbf = 'DBSourse';

type
  TDataSourseOptions = set of (dboFreeTable, dboAutoOpen);

type
  PDataSourse = ^TDataSourse;
  PFieldWraper = ^TFieldWraper;
  TFieldWraper = object(TObject)
    FieldName:PString;
    Stream:PStream;
    constructor Init(AField:PField);
    destructor Done;virtual;
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
    procedure SetFieldProp(F:PField);
  end;

  TDataSourse = object(TView)
    dbOptions:TDataSourseOptions;
    TableName:PString;
    Master:PDataSourse;
    IndexLists:PStrings;
    DatabaseName:PString;
    constructor Init;
    destructor Done;virtual;
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
    procedure Append;virtual;
    function Active:boolean;virtual;
    procedure Awaken; virtual;
    procedure Draw;virtual;
    function BOF:boolean;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    function EOF:boolean;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    function RecNo:LongInt;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    procedure Go( APos:Longint);virtual;{$IFDEF EAM}abstract;{$ENDIF}
    procedure SetKey;virtual;
    procedure EditKey;virtual;
    function GotoKeyEx:LongInt;virtual;
    function FindKeyEx:LongInt;virtual;
    procedure MoveBy( ACount:LongInt);virtual;

    function LastRecEx:LongInt;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    function NextRecEx:LongInt;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    function PriorRecEx:LongInt;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    function FirstRecEx:LongInt;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    function LastRec:LongInt;
    function NextRec:LongInt;
    function PriorRec:LongInt;
    function FirstRec:LongInt;
    function GotoKey:LongInt;
    function FindKey:LongInt;

    function FieldCount:Word;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    function RecordCount:Longint;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    procedure Cancel;virtual;
    procedure Edit;virtual;
    procedure Post;virtual;
    function Fields(Num:integer):PField;
    function FieldByName(AName:String):PField;
    function FieldDefs:PCollection;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    function GetFileName:FNameStr;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    procedure HandleEvent(var Event:TEvent);virtual;
    function RecordSize:word;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    procedure UpData;
    procedure NewTable(FileName:FNameStr);virtual;
    procedure Close;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    procedure Open;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    procedure SetActive(Action:boolean);
    function  GetActive:boolean;
    function  fReadOnly:boolean;virtual;
    function HasSorted:boolean;virtual;
(*    procedure FreeBookmark(Bookmark: PBookmark);virtual;{$IFDEF EAM}abstract;{$ENDIF}
    function GetBookmark:PBookmark;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    procedure GotoBookmark(Bookmark: PBookmark);virtual;{$IFDEF EAM}abstract;{$ENDIF}
    function isPosBookmark(Bookmark: PBookmark):boolean;virtual;{$IFDEF EAM}abstract;{$ENDIF}*)

 {property}
    function TableType:TTableType;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    function IndexDefs:PCollection;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    function DSState:TDataSetState;virtual;
    function DSStatus:TDataSetStatus;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    function ReadOnly:boolean;
    function Filtred:boolean;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    function Filter:string;virtual;{$IFDEF EAM}abstract;{$ENDIF}
    procedure SetFiltred(AFiltred:boolean);virtual;{$IFDEF EAM}abstract;{$ENDIF}
    procedure SetFilter(AFilter:string);virtual;{$IFDEF EAM}abstract;{$ENDIF}
  private
    WraperList:PCollection;
    procedure CreateWraper;
    procedure SetWraper;
    procedure DisposeWraper;
  end;

type
  PDBSourse = ^TDBSourse;
  TDBSourse = object(TDataSourse)
    DataSet:PDataSet;
    constructor Init(aDataSet:PDataSet);
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
    destructor Done;virtual;
    procedure Append;virtual;
    procedure Awaken; virtual;

    function BOF:boolean;virtual;
    procedure Cancel;virtual;

    function FieldCount:Word;virtual;
    function RecordCount:Longint;virtual;
    function  DataSize:word;virtual;

    function DeletedRec:Boolean;
    procedure DeleteRecord;
    procedure Edit;virtual;

    procedure SetKey;virtual;
    procedure EditKey;virtual;
    function Location:boolean;
    function EOF:boolean;virtual;
    function FieldDefs:PCollection;virtual;
    procedure GetData(var Rec);virtual;
    function GetFileName:FNameStr;virtual;
    function RecNo:LongInt;virtual;
    procedure Go( APos:Longint);virtual;

    function FindKeyEx:LongInt;virtual;
    function GotoKeyEx:Longint;virtual;
    function FirstRecEx:Longint;virtual;
    function LastRecEx:Longint;virtual;
    function NextRecEx:Longint;virtual;
    function PriorRecEx:Longint;virtual;
    procedure MoveBy( ACount:LongInt);virtual;

    function RecordSize:word;virtual;
    procedure SetData(var Rec);virtual;
    function TableType:TTableType;virtual;
    procedure NewTable(FileName:FNameStr);virtual;
    procedure Post;virtual;
    procedure Close;virtual;
    procedure Open;virtual;
    function Active:boolean;virtual;
    function IndexDefs:PCollection;virtual;
    procedure RecalcIndexList;
    function MasterField:PField;
    function DSState:TDataSetState;virtual;
    function DSStatus:TDataSetStatus;virtual;
    function fReadOnly:boolean;virtual;
    procedure SetMaster(AMaster:PDBSourse);
    function HasSorted:boolean;virtual;
    function Filtred:boolean;virtual;
    function Filter:string;virtual;
    procedure SetFiltred(AFiltred:boolean);virtual;
    procedure SetFilter(AFilter:string);virtual;
{    procedure FreeBookmark(Bookmark: PBookmark);virtual;
    function GetBookmark:PBookmark;virtual;
    procedure GotoBookmark(Bookmark: PBookmark);virtual;
    function isPosBookmark(Bookmark: PBookmark):boolean;virtual;}
  end;

const
  RDataSourse: TStreamRec = (
     ObjType: rcDataSourse;
     VmtLink: Ofs(TypeOf(TDataSourse)^);
     Load:    @TDataSourse.Load;
     Store:   @TDataSourse.Store
  );
const
  RDBSourse: TStreamRec = (
     ObjType: rcDBSourse;
     VmtLink: Ofs(TypeOf(TDBSourse)^);
     Load:    @TDBSourse.Load;
     Store:   @TDBSourse.Store
  );

const
  RFieldWraper: TStreamRec = (
     ObjType: rcFieldWraper;
     VmtLink: Ofs(TypeOf(TFieldWraper)^);
     Load:    @TFieldWraper.Load;
     Store:   @TFieldWraper.Store
  );

procedure RegisterData;
implementation
uses Ext_Str, Dos, App
{$IFDEF FPC}
,Commands
{$ENDIF};

constructor TDataSourse.Init;
var
  R:TRect;
begin
  R.Assign(1,1,12,2);
  inherited Init(R);
  dbOptions := [dboFreeTable,dboAutoOpen];
  Options:=Options or ofPreProcess;
  EventMask:=EventMask or evBroadcast or evCommand;
  if DesignTime then Show
  else Hide;
  IndexLists:=New(PStrings, Init);
  ComponentType:=ctDataSourse;
end;

destructor TDataSourse.Done;
begin
  DisposeStr(TableName);
  Dispose(IndexLists, Done);
  DisposeStr(DatabaseName);
  DisposeWraper;
  inherited Done;
end;

procedure TDataSourse.CreateWraper;
var i:integer;
begin
  DisposeWraper;
  if FieldDefs<>nil then
  begin
    WraperList:=New(PCollection, Init(FieldDefs^.Count, 10));
    for i:=0 to FieldDefs^.Count-1 do
      WraperList^.Insert(New(PFieldWraper, Init(FieldDefs^.At(i))));
  end;
end;

procedure TDataSourse.SetWraper;
procedure DoSet(W:PFieldWraper);far;
var F:PField;
 function Test(Item:PField):boolean;far;
 begin
   Test:=Item^.Name^=W^.FieldName^;
 end;
begin
  F:=FieldDefs^.FirstThat(@Test);
  W^.SetFieldProp(F);
end;
begin
  if (WraperList<>nil) and (FieldDefs<>nil) then
     WraperList^.ForEach(@DoSet);
end;

procedure TDataSourse.DisposeWraper;
begin
  if WraperList<>nil then
  begin
    Dispose(WraperList, Done);
    WraperList:=nil;
  end;
end;

constructor TDataSourse.Load(var S:TStream);
begin
  inherited Load(s);
  S.Read(dbOptions, SizeOf(dbOptions));
  TableName:=S.ReadStr;
  IndexLists:=PStrings(S.Get);
  DatabaseName:=S.ReadStr;
  GetPeerViewPtr(S,Master);
  if DesignTime then Show
  else Hide;
  WraperList:=Pointer(S.Get);
end;

procedure TDataSourse.Store(var S:TStream);
begin
  inherited Store(S);
  S.Write(dbOptions, SizeOf(dbOptions));
  S.WriteStr(TableName);
  S.Put(IndexLists);
  S.WriteStr(DatabaseName);
  PutPeerViewPtr(S,Master);
  CreateWraper;
  S.Put(WraperList);
end;

procedure TDataSourse.Awaken;
begin
  Message(Owner, evBroadcast, cmAfterLoadDS, @Self);
  if dboAutoOpen in dbOptions then
     Message(Owner, evBroadcast, cmNewTable, @Self);
end;

function TDataSourse.FieldByName(AName:String):PField;
var P:Pointer;
    SS:PString;
function Test(Item:PField):boolean;far;
begin
  Test:=stUpCase(Trim(Item^.Name^))=AName;
end;
begin
  if FieldDefs=nil then P:=nil
  else
  begin
    AName:=stUpCase(Trim(AName));
    P:=FieldDefs^.FirstThat(@Test);
    if P=nil then
    begin
      SS:=@AName;
      DBError(edbFieldNotFound, SS);
    end;
  end;
  FieldByName:=P;
end;

procedure TDataSourse.Draw;
var
  Color: Word;
  B: TDrawBuffer;
  Dir: DirStr;
  FName: NameStr;
  Ext: ExtStr;
begin
  Color := GetColor($0402);
  MoveChar(B[0], ' ', Byte(Color), Size.X);
  if TableName <> nil then
  begin
    FSplit(TableName^, Dir, FName, Ext);
    MoveCStr(B[1], FName+Ext, Color);
  end
  else
  if ComponentName<>nil then MoveCStr(B[1], ComponentName^, Color);
  WriteLine(0, 0, Size.X, 1, B);
end;

function TDataSourse.Fields(Num:integer):PField;
begin
  if (FieldDefs=nil) or (Num<0) or (Num>FieldDefs^.Count) then
     Fields:=nil
  else Fields:=FieldDefs^.At(Num);
end;

procedure TDataSourse.HandleEvent(var Event:TEvent);
begin
  case Event.What of
     evCommand:
     case Event.Command of
       cmPrevRec:PriorRec;
       cmNextRec:NextRec;
       cmFirstRec:FirstRec;
       cmLastRec:LastRec;
       cmMoveBy:MoveBy(Event.InfoLong);
       cmEditRec:Edit;
       cmAppendRec:Append;
       cmPostRec:Post;
       cmCancelRec:Cancel;

       cmFindDataSourse:if (Event.InfoPtr<>nil) and (TableName<>nil)
                        and (stUpCase(PString(Event.InfoPtr)^)<>stUpCase(TableName^)) then exit;
     else
        exit;
     end;
     evBroadcast:
     begin
       case Event.Command of
         cmUpDataDS:if Event.InfoPtr=Master then
                    begin
                      FirstRec;
                      UpData;
                    end;
         cmDestroed:if Event.InfoPtr=Master  then Master:=nil;
       end;
       exit;
     end;
  else
    exit;
  end;
  UpData;
  ClearEvent(Event);
end;

procedure TDataSourse.UpData;
procedure DoMessage(P:PView);far;
begin
  if (P^.ComponentType in DBComponents) and (P<>@Self) then
     Message( P, evBroadcast, cmUpDataDS, @Self);
end;
begin
  Message( Owner, evBroadcast, cmUpDataDS, @Self);
  Owner^.ForEach(@DoMessage);
end;

{$IFNDEF EAM}
function TDataSourse.Filtred:boolean;
begin Abstract;
end;
function TDataSourse.Filter:string;
begin Abstract;
end;
procedure TDataSourse.SetFiltred(AFiltred:boolean);
begin Abstract;
end;
procedure TDataSourse.SetFilter(AFilter:string);
begin Abstract;
end;
function TDataSourse.PriorRecEx:Longint;
begin Abstract;
end;
function TDataSourse.NextRecEx:Longint;
begin Abstract;
end;
function TDataSourse.FirstRecEx:Longint;
begin Abstract;
end;
function TDataSourse.LastRecEx:Longint;
begin Abstract;
end;
procedure TDataSourse.Go( APos:Longint);
begin Abstract;
end;
function TDataSourse.RecNo:LongInt;
begin Abstract;
end;
function TDataSourse.FieldCount:Word;
begin Abstract;
end;
function TDataSourse.EOF:boolean;
begin Abstract;
end;
function TDataSourse.GetFileName:FNameStr;
begin Abstract;
end;
function TDataSourse.BOF:boolean;
begin Abstract;
end;
function TDataSourse.TableType:TTableType;
begin Abstract;
end;
function TDataSourse.RecordCount:Longint;
begin Abstract;
end;
function TDataSourse.RecordSize:word;
begin Abstract;
end;
function TDataSourse.FieldDefs:PCollection;
begin Abstract;
end;
function TDataSourse.IndexDefs:PCollection;
begin Abstract;
end;
procedure TDataSourse.Close;
begin abstract;
end;
procedure TDataSourse.Open;
begin abstract;
end;
function TDataSourse.DSStatus:TDataSetStatus;
begin abstract;
end;
{procedure TDataSourse.FreeBookmark(Bookmark: PBookmark);
begin abstract;
end;
function TDataSourse.GetBookmark:PBookmark;
begin abstract;
end;
procedure TDataSourse.GotoBookmark(Bookmark: PBookmark);
begin abstract;
end;
function TDataSourse.isPosBookmark(Bookmark: PBookmark):boolean;
begin abstract;
end;}
{$ENDIF}

function TDataSourse.HasSorted:boolean;
begin
  HasSorted:=false;
end;

procedure TDataSourse.MoveBy( ACount:LongInt);
var
  I,I1:LongInt;
  NextR:boolean;
begin
  if ACount=0 then exit;
  I:=RecNo;
  NextR:=ACount>0;
  I1:=I+ACount;
  while i<>I1 do
    if NextR then
    begin
      NextRec;
      inc(i);
    end
    else
    begin
      PriorRec;
      dec(i);
    end
end;

function TDataSourse.LastRec:LongInt;
begin
  LastRecEx;
  UpData;
end;

function TDataSourse.NextRec:LongInt;
begin
  NextRecEx;
  UpData;
end;

function TDataSourse.PriorRec:LongInt;
begin
  PriorRecEx;
  UpData;
end;

function TDataSourse.FirstRec:LongInt;
begin
  FirstRecEx;
  UpData;
end;

function TDataSourse.GotoKey:LongInt;
begin
  GotoKey:=GotoKeyEx;
  UpData;
end;

function TDataSourse.FindKey:LongInt;
begin
  FindKey:=FindKeyEx;
  UpData;
end;

procedure TDataSourse.Edit;
begin
  SingleError(edbNotValidOperation);
end;

function TDataSourse.FindKeyEx:LongInt;
begin
  SingleError(edbNotValidOperation);
end;

procedure TDataSourse.Cancel;
begin
  SingleError(edbNotValidOperation);
end;

procedure TDataSourse.Append;
begin
  SingleError(edbNotValidOperation);
end;
function TDataSourse.GotoKeyEx:Longint;
begin
  SingleError(edbNotValidOperation);
end;

procedure TDataSourse.NewTable(FileName:FNameStr);
begin
  SingleError(edbNotValidOperation);
end;

procedure TDataSourse.Post;
begin
  SingleError(edbNotValidOperation);
end;

procedure TDataSourse.SetKey;
begin
  SingleError(edbNotValidOperation);
end;

procedure TDataSourse.EditKey;
begin
  SingleError(edbNotValidOperation);
end;

function TDataSourse.Active:boolean;
begin
  Active:=false;
end;

function TDataSourse.ReadOnly:boolean;
begin
  ReadOnly:=fReadOnly;
end;

function  TDataSourse.fReadOnly:boolean;
begin
  fReadOnly:=true;
end;

procedure TDataSourse.SetActive(Action:boolean);
begin
  if Action=Active then exit;
  if Action then Open else Close;
end;

function  TDataSourse.GetActive:boolean;
begin
  GetActive:=Active;
end;

function TDataSourse.DSState:TDataSetState;
begin
  DSState:=dsBrowse;
end;


   { TDBSourse }
constructor TDBSourse.Init(aDataSet:PDataSet);
begin
  inherited Init;
  DataSet:=aDataSet;
  RecalcIndexList;
  ComponentType:=ctDBSourse;
end;

destructor TDBSourse.Done;
begin
  if (dboFreeTable in dbOptions) and (DataSet<>nil) then
  begin
    DataSet^.Free;
    DataSet:=nil;
    if DesignTime then Message(Application, evBroadcast, cmNewTable, @Self)
    else Message(Owner, evBroadcast, cmNewTable, @Self);
  end;
  inherited Done;
end;


procedure TDBSourse.NewTable(FileName:FNameStr);
var i:integer;
    aFileName:FNameStr;
    P:Pointer;
begin
  if DatabaseName<>nil then aFileName:='<'+DatabaseName^+'>'+FileName
  else aFileName:=FileName;
  aFileName:=ReplaceExt(aFileName,'.DBF',false);
  if FileExists(FullName(aFileName)) then
  begin
    if DataSet<>nil then DataSet^.Free;
{    DataSet:=New(PDbf, Init( aFileName,stOpen));}
    DataSet:=OpenDataSet(aFileName);
    for i:=0 to IndexLists^.Count-1 do
        DataSet^.OpenIndex(IndexLists^.Str(i));
    if TableName^=FileName then
       SetWraper;
    DisposeWraper;
    DisposeStr(TableName);
    TableName:=NewStr(FileName);
    if DesignTime then
       Message(Application, evBroadcast, cmNewTable, @Self)
    else Message(Owner, evBroadcast, cmNewTable, @Self);
  end
  else
  begin
    P:=@FileName;
    DBError(edbFileNotOpen, P);
  end;
end;

function TDBSourse.Active:boolean;
begin
  Active:=(DataSet<>nil) and (DataSet^.State<>dsInactive);
end;

procedure TDBSourse.Close;
begin
  if DataSet<>nil then
  begin
    CreateWraper;
    DataSet^.Free;
    DataSet:=nil;
    if DesignTime then
       Message(Application, evBroadcast, cmNewTable, @Self)
    else Message(Owner, evBroadcast, cmNewTable, @Self);
  end;
end;

procedure TDBSourse.Open;
begin
  if TableName<>nil then
  begin
    NewTable(TableName^);
    SetWraper;
    DisposeWraper;
  end
  else SingleError(edbTableNameRecvared);
end;

constructor TDBSourse.Load(var S:TStream);
var L:longint;
    B:boolean;
    i:integer;
begin
  inherited Load(S);
  if dboAutoOpen in dbOptions then
  begin
    S.Read(B, SizeOf(Boolean));
    if B then
    begin
      if DatabaseName<>nil then
         DataSet:=OpenDataSet('<'+DatabaseName^+'>\'+TableName^)
      else DataSet:=OpenDataSet(TableName^);
      S.Read(i, SizeOf(integer));
      S.Read(L, SizeOf(Longint));
      if DataSet<>nil then
      begin
        DataSet^.MasterFieldName:=S.ReadStr;
        for i:=0 to IndexLists^.Count-1 do
            DataSet^.OpenIndex(IndexLists^.Str(i));
        if (i<>-1) and (I<DataSet^.IndexDefs^.Count) then
           DataSet^.Index:=DataSet^.IndexDefs^.At(I)
        else DataSet^.Index:=nil;
        DataSet^.Go(L);
      end;
    end;
  end;
  SetWraper;
  DisposeWraper;
end;

procedure TDBSourse.Store(var S:TStream);
var L:longint;
    B:boolean;
    i:integer;
begin
  inherited Store(S);
  if dboAutoOpen in dbOptions then
  begin
    B:=DataSet<>nil;
    S.Write(B, SizeOf(Boolean));
    if B then
    begin
      if DataSet^.IndexDefs<>nil then
         i:=DataSet^.IndexDefs^.IndexOf(DataSet^.Index)
      else i:=-1;
      S.Write(i, SizeOf(integer));
      L:=RecNo;
      S.Write(L, SizeOf(Longint));
      S.WriteStr(DataSet^.MasterFieldName);
    end;
  end;
end;

procedure TDBSourse.Awaken;
begin
  inherited Awaken;
  if Master<>nil then
     DataSet^.SetMaster(PDBSourse(Master)^.DataSet, DataSet^.MasterFieldName^);
end;

function TDBSourse.FieldDefs:PCollection;
begin
  if DataSet<>nil then FieldDefs:=DataSet^.FieldDefs
  else FieldDefs:=nil;
end;

procedure TDBSourse.Edit;
begin
  DataSet^.Edit;
end;

procedure TDBSourse.Cancel;
begin
  DataSet^.Cancel;
end;

procedure TDBSourse.Append;
begin
  DataSet^.Append;
end;

function TDBSourse.GotoKeyEx:Longint;
begin
  DataSet^.GotoKey;
  GotoKeyEx:=DataSet^.RecNo;
end;

function TDBSourse.FindKeyEx:LongInt;
begin
  DataSet^.FindKey;
  FindKeyEx:=DataSet^.RecNo;
end;

function TDBSourse.DeletedRec:Boolean;
begin
  DeletedRec:=DataSet^.DeletedRec;
end;

procedure TDBSourse.DeleteRecord;
begin
  Message(Owner, evBroadcast, cmBeforeDelete, @Self);
  DataSet^.Delete;
  Message(Owner, evBroadcast, cmAfterDelete, @Self);
end;

{procedure TDBSourse.SetDeleted;
begin
  DataSet^.SetDeleted(Del);
end;

function TDBSourse.DisplayDeleted;
begin
  DisplayDeleted:=DBFTable^.DispDeleted;
end;

procedure TDBSourse.RecalRecord;
begin
  DataSet^.Recall;
end;}

function TDBSourse.PriorRecEx:Longint;
begin
  DataSet^.Prior;
  PriorRecEx:=DataSet^.RecNo;
end;

function TDBSourse.NextRecEx:Longint;
begin
  DataSet^.Next;
  NextRecEx:=DataSet^.RecNo;
end;

function TDBSourse.FirstRecEx:Longint;
begin
  DataSet^.First;
  FirstRecEx:=DataSet^.RecNo;
end;

function TDBSourse.LastRecEx:Longint;
begin
  DataSet^.Last;
  LastRecEx:=DataSet^.RecNo;
end;


procedure TDBSourse.MoveBy( ACount:LongInt);
begin
  DataSet^.MoveBy( ACount);
end;

procedure TDBSourse.Go( APos:Longint);
begin
  DataSet^.Go( APos);
end;

function TDBSourse.RecNo:LongInt;
begin
  RecNo:=DataSet^.RecNo;
end;

function TDBSourse.FieldCount:Word;
begin
  FieldCount:=DataSet^.FieldCount
end;

function TDBSourse.EOF:boolean;
begin
  EOF:=DataSet^.EOF
end;

function TDBSourse.BOF:boolean;
begin
  BOF:=DataSet^.BOF
end;

function TDBSourse.GetFileName:FNameStr;
begin
  GetFileName:=DataSet^.TableName^
end;

function TDBSourse.TableType:TTableType;
begin
  TableType:=ttDBase;
end;

function TDBSourse.RecordCount:Longint;
begin
  RecordCount:=DataSet^.RecordCount
end;

function TDBSourse.RecordSize:word;
begin
  RecordSize:=DataSet^.RecordSize
end;

procedure TDBSourse.SetData(var Rec);
var ADataSet:PDataSet absolute Rec;
begin
  if ADataSet<>nil then
  begin
    if DataSet<>nil then DataSet^.Free;
    DataSet:=ADataSet;
    Message(Owner, evBroadcast, cmNewTable, @Self);
  end;
end;

procedure TDBSourse.GetData(var Rec);
var ADataSet:PDataSet absolute Rec;
begin
  if ADataSet=nil then ADataSet:=DataSet;
end;

function TDBSourse.DataSize:word;
begin
  DataSize:=SizeOf(Pointer);
end;

procedure TDBSourse.Post;
begin
  Message(Owner, evBroadcast, cmBeforePost, @Self);
  DataSet^.Post;
  Message(Owner, evBroadcast, cmAfterPost, @Self);
end;

function TDBSourse.IndexDefs:PCollection;
begin
  IndexDefs:=DataSet^.IndexDefs;
end;

procedure TDBSourse.RecalcIndexList;
var Dir: DirStr;
    Name: NameStr;
    Ext: ExtStr;
procedure DoAdd(P:PIndexObject);far;
begin
  FSplit(P^.FileName^, Dir, Name, Ext);
  if (DataBaseName<>nil) and
     (FullName('<'+DataBaseName^+'>'+Name+Ext)=P^.FileName^) then
     IndexLists^.Insert(NewStr('<'+DataBaseName^+'>'+Name+Ext))
  else IndexLists^.Insert(NewStr(P^.FileName^));
end;
begin
  if DataSet=nil then exit;
  IndexLists^.FreeAll;
  if not ((TableName<>nil) and ((FullName(TableName^)=DataSet^.TableName^) or
     ((DataBaseName<>nil) and
      (FullName('<'+DataBaseName^+'>'+TableName^)=DataSet^.TableName^)))) then
    TableName:=NewStr(DataSet^.TableName^);
  if DataSet^.IndexDefs<>nil then
     DataSet^.IndexDefs^.ForEach(@DoAdd);
end;

function TDBSourse.MasterField:PField;
begin
  if DataSet=nil then MasterField:=nil
  else MasterField:=DataSet^.MasterField;
end;

function TDBSourse.DSState:TDataSetState;
begin
  if DataSet<>nil then DSState:=DataSet^.State
  else DSState:=dsBrowse;
end;
procedure TDBSourse.SetKey;
begin
  if DataSet<>nil then DataSet^.SetKey;
end;
procedure TDBSourse.EditKey;
begin
  if DataSet<>nil then DataSet^.EditKey;
end;

function TDBSourse.DSStatus:TDataSetStatus;
begin
  if DataSet<>nil then
  begin
    DSStatus:=DataSet^.DSStatus;
    DataSet^.DSStatus:=dsOk;
  end;
end;

function TDBSourse.fReadOnly:boolean;
begin
  fReadOnly:=DataSet^.ReadOnly;
end;

function TDBSourse.Location:boolean;
var L:Longint;
begin
  Location:=false;
  if DataSet<>nil then
  begin
    L:=DataSet^.RecNo;
    if DataSet^.Location then
    begin
      UpData;
      Location:=true;
    end
    else if not (soInclude in LocateOptions) then DataSet^.Go(L);
  end;
end;

procedure TDBSourse.SetMaster(AMaster:PDBSourse);
begin
  DataSet^.SetMaster(AMaster^.DataSet, '');
  if DataSet^.Master<>nil then
     Master:=AMaster;
end;

function TDBSourse.HasSorted:boolean;
begin
  HasSorted:=DataSet^.Index<>nil;
end;

function TDBSourse.Filtred:boolean;
begin
  Filtred:=(DataSet<>nil) and (DataSet^.Filtred);
end;

function TDBSourse.Filter:string;
begin
  if (DataSet<>nil) and (DataSet^.Filter<>nil) then
     Filter:=DataSet^.Filter^
  else Filter:='';
end;

procedure TDBSourse.SetFiltred(AFiltred:boolean);
begin
  if DataSet<>nil then
  begin
    DataSet^.SetFiltred(AFiltred);
    UpData;
  end;
end;

procedure TDBSourse.SetFilter(AFilter:string);
begin
  if DataSet<>nil then DataSet^.SetFilter(AFilter);
end;

  { TFieldWraper }

constructor TFieldWraper.Init(AField:PField);
var Writer:PWriter;
begin
  inherited Init;
  if AField<>nil then
  begin
    Stream:=New(PMemoryStream,Init(32,32));
    Writer:=New(PWriter, Init(Stream));
    FieldName:=NewStr(AField^.Name^);
    AField^.Store(Writer);
    Dispose(Writer, Done);
  end;
end;

destructor TFieldWraper.Done;
begin
  DisposeStr(FieldName);
  if Stream<>nil then Stream^.Free;
  inherited Done;
end;

constructor TFieldWraper.Load(var S:TStream);
var ASize:Longint;
begin
  inherited Init;
  FieldName:=S.ReadStr;
  S.Read(ASize, SizeOf(Longint));
  if ASize>0 then
  begin
    Stream:=New(PMemoryStream,Init(32,32));
    Stream^.CopyFrom(S, ASize)
  end;
end;

procedure TFieldWraper.Store(var S:TStream);
var ASize:Longint;
begin
  S.WriteStr(FieldName);
  if Stream<>nil then ASize:=Stream^.GetSize else ASize:=0;
  S.Write(ASize, SizeOf(Longint));
  if ASize>0 then
  begin
     Stream^.Seek(0);
     S.CopyFrom(Stream^, ASize)
  end;
end;

procedure TFieldWraper.SetFieldProp(F:PField);
var Reader:PReader;
begin
  if (F<>nil) and (Stream<>nil) then
  begin
    Stream^.Seek(0);
    Reader:=New(PReader, Init(Stream));
    F^.Load(Reader);
    Dispose(Reader, Done);
  end;
end;

procedure RegisterData;
begin
{  RegisterType(RDataSourse);}
  RegisterType(RDBSourse);
  RegisterType(RFieldWraper);
end;

end.
