{************************************************}
{                                                }
{   Data access visual components                }
{                                                }
{   Turbo Pascal 7                               }
{   FreePacal                                    }
{   Delphi 2 - 5                                 }
{   Virtual Pascal 2.1                           }
{                                                }
{   Copyright (c) 1995-2000 by Alexs             }
{                                                }
{************************************************}

{$IFDEF VER70}
{$O+}
{$ENDIF}

{$I Define.inc}
unit DBCtrls;
interface
uses Objects, DAE, Drivers, DataCtrl, Views, Dialogs, Clases,
     AddCntrl, Register, Validate, Editors, ShardEdt;

const
   CDBLookupCombo = #19#22#23#6;
   PalDBLookupCombo: String[Length(CDBLookupCombo)] = CDBLookupCombo;

type
  TDisplayType = (fdNative, fdFloat, fdCurrency);

type
  PDBText = ^TDBText;
  TDBText = object(TStaticText)
    Field:PField;
    DS:PDataSourse;
    FieldName:PString;
    DisplayType:TDisplayType;
    constructor Init(Bounds:TRect; ADS:PDataSourse; Name:String);
    destructor Done;virtual;
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
    procedure GetText(var S: String); virtual;
    procedure HandleEvent(var Event:TEvent);virtual;
  end;

type
  PDBLockUpText = ^TDBLockUpText;
  TDBLockUpText = object(TDBText)
    Items:PStrings;
    constructor Init(Bounds:TRect; ADS:PDataSourse; Name:String;
                     AItems:PSItem);
    destructor Done;virtual;
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
    procedure GetText(var S: String); virtual;
  end;

type
  PDBLookupEdit = ^TDBLookupEdit;
  TDBLookupEdit = object(TDBLockUpText)
    constructor Init(Bounds:TRect; ADS:PDataSourse; Name:String;
                     AItems:PSItem);
    procedure Draw;virtual;
    procedure HandleEvent(var Event:TEvent);virtual;
    function GetPalette: PPalette; virtual;
  end;

type
  PDBCluster = ^TDBCluster;
  TDBCluster = object(TCluster)
    Field:PField;
    DS:PDataSourse;
    FieldName:PString;
    ReadOnly:boolean;
    constructor Init(Bounds:TRect; ADS:PDataSourse; Name:String;
                     AItems:PSItem; AReadOnly:Boolean);
    destructor Done;virtual;
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
    procedure HandleEvent(var Event:TEvent);virtual;
    procedure DBUpdate;virtual;
  end;

type
  PDBRadioButtons = ^TDBRadioButtons;
  TDBRadioButtons = object(TDBCluster)
    constructor Init(Bounds:TRect; ADS:PDataSourse; Name:String;
                     AItems:PSItem; AReadOnly:Boolean);
    procedure Draw; virtual;
    function Mark(Item: Integer): Boolean; virtual;
    procedure MovedTo(Item: Integer); virtual;
    procedure Press(Item: Integer); virtual;
    procedure SetData(var Rec); virtual;
  end;

type
  PDBCheckBox = ^TDBCheckBox;
  TDBCheckBox = object(TDBCluster)
    ValueChecked:PString;
    ValueUnchecked:PString;
    constructor Init(Bounds:TRect; ADS:PDataSourse; Name:String;
                     AItems:string; AReadOnly:Boolean;
                     AValueChecked,AValueUnchecked:String);
    destructor Done;virtual;
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
    procedure Draw; virtual;
    function Mark(Item: Integer): Boolean; virtual;
    procedure Press(Item: Integer); virtual;
    procedure DBUpdate;virtual;
  end;

type
  PDBLookupCombo = ^TDBLookupCombo;
  TDBLookupCombo = object(TView)
    DataSourse:PDataSourse;
    LookupSourse:PDataSourse;
    DataField:PField;
    LookupField:PField;
    LookupDisplay:PField;
    DataFieldName:PString;
    LookupFieldName:PString;
    LookupDisplayName:PString;
    DisplayListName:PString;
    ReadOnly:boolean;
    constructor Init(Bounds:TRect; ADataSourse, ALookupSourse:PDataSourse;
                     ASName, ALName, ARName, ADisplayListName:string; AReadOnly:boolean);
    destructor Done;virtual;
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
    procedure HandleEvent(var Event:TEvent);virtual;
    procedure Draw;virtual;
    function GetPalette: PPalette; virtual;
    procedure CloseUp; virtual;
    procedure Lock;
    procedure UnLock;
  private
    LockFlag:integer;
  end;

type
  PDBEdit = ^TDBEdit;
  TDBEdit = object(TInputLine)
    DS:PDataSourse;
    Field:PField;
    FieldName:PString;
    constructor Init(var Bounds:TRect; ADS:PDataSourse; Name:string);
    destructor Done;virtual;
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
    procedure Draw;virtual;
    procedure HandleEvent(var Event:TEvent);virtual;
    procedure UpData;
    procedure SetState(AState: Word; Enable: Boolean);virtual;
    function Valid(Command: Word): Boolean; virtual;
    function  DataSize:word;virtual;
    procedure GetData(var Rec); virtual;
    procedure SetData(var Rec); virtual;
    procedure ConectBase(ADS:PDataSourse; Name:string);
  end;

type
  PDBDateEdit = ^TDBDateEdit;
  TDBDateEdit = object(TDBEdit)
    DefaultToday : Boolean;
    constructor Init(var Bounds:TRect; ADS:PDataSourse; Name:string);
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
    procedure Draw;virtual;
    procedure HandleEvent(var Event:TEvent);virtual;
    function GetPalette: PPalette;virtual;
  end;

type
  PDBListBox = ^TDBListBox;
  TDBListBox = object(TListBox)
    Field:PField;
    DS:PDataSourse;
    FieldName:PString;
    ReadOnly:boolean;
  end;

type
  PDBNavigatorBtn = ^TDBNavigatorBtn;
  TDBNavigatorBtn = object(TButton)
    DataSourse:PDataSourse;
    constructor Init(var Bounds: TRect; ATitle: TTitleStr; ACommand: Word;
                         AFlags: Byte; ADataSourse:PDataSourse);
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
    procedure Press; virtual;
    procedure HandleEvent(var Event:TEvent);virtual;
  end;

type
  PDBMemo = ^TDBMemo;
  TDBMemo = object(TEditor)
    DataSourse:PDataSourse;
    Field:PField;
    FieldName:PString;
    constructor Init(var Bounds: TRect;
      AHScrollBar, AVScrollBar: PScrollBar;
      AIndicator: PIndicator; ADS:PDataSourse; AName:string);
    constructor Load(var S: TStream);
    function GetPalette: PPalette; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure Store(var S: TStream);
    function SetBufSize(NewSize: Word): Boolean; virtual;
    procedure InitBuffer; virtual;
    procedure DoneBuffer; virtual;
    procedure UpData;
    procedure SaveToBase;
    procedure SetState(AState: Word; Enable: Boolean); virtual;
  end;

const
  RDBMemo: TStreamRec = (
    ObjType: rcDBMemo;
    VmtLink: Ofs(TypeOf(TDBMemo)^);
    Load: @TDBMemo.Load;
    Store: @TDBMemo.Store
  );

const
  RDBLookupCombo: TStreamRec = (
     ObjType: rcDBLookupCombo;
     VmtLink: Ofs(TypeOf(TDBLookupCombo)^);
     Load:    @TDBLookupCombo.Load;
     Store:   @TDBLookupCombo.Store
  );
const
  RDBText: TStreamRec = (
     ObjType: rcDBText;
     VmtLink: Ofs(TypeOf(TDBText)^);
     Load:    @TDBText.Load;
     Store:   @TDBText.Store
  );
const
  RDBEdit: TStreamRec = (
     ObjType: rcDBEdit;
     VmtLink: Ofs(TypeOf(TDBEdit)^);
     Load:    @TDBEdit.Load;
     Store:   @TDBEdit.Store
  );
const
  RDBLockUpText: TStreamRec = (
     ObjType: rcDBLockUpText;
     VmtLink: Ofs(TypeOf(TDBLockUpText)^);
     Load:    @TDBLockUpText.Load;
     Store:   @TDBLockUpText.Store
  );

const
  RDBRadioButtons: TStreamRec = (
     ObjType: rcDBRadioButtons;
     VmtLink: Ofs(TypeOf(TDBRadioButtons)^);
     Load:    @TDBRadioButtons.Load;
     Store:   @TDBRadioButtons.Store
  );
const
  RDBCheckBox: TStreamRec = (
     ObjType: rcDBCheckBox;
     VmtLink: Ofs(TypeOf(TDBCheckBox)^);
     Load:    @TDBCheckBox.Load;
     Store:   @TDBCheckBox.Store
  );
const
  RDBListBox: TStreamRec = (
     ObjType: rcDBListBox;
     VmtLink: Ofs(TypeOf(TDBListBox)^);
     Load:    @TDBListBox.Load;
     Store:   @TDBListBox.Store
  );
const
  RDBLookupEdit: TStreamRec = (
     ObjType: rcDBLookupEdit;
     VmtLink: Ofs(TypeOf(TDBLookupEdit)^);
     Load:    @TDBLookupEdit.Load;
     Store:   @TDBLookupEdit.Store
  );
const
  RDBNavigatorBtn: TStreamRec = (
     ObjType: rcDBNavigatorBtn;
     VmtLink: Ofs(TypeOf(TDBNavigatorBtn)^);
     Load:    @TDBNavigatorBtn.Load;
     Store:   @TDBNavigatorBtn.Store
  );
const
  RDBDateEdit: TStreamRec = (
    ObjType: rcDBDateEdit;
    VmtLink: Ofs(TypeOf(TDBDateEdit)^);
    Load: @TDBDateEdit.Load;
    Store: @TDBDateEdit.Store
  );
procedure RegisterDBCtrls;
implementation
uses DBGrids, Ext_Str, App, TVForms, Ext_Dos, Ext_App, Ext_Type,
     Ext_Math, Memory;


{TDBLookupCombo}
constructor TDBLookupCombo.Init(Bounds:TRect; ADataSourse, ALookupSourse:PDataSourse;
                               ASName, ALName, ARName, ADisplayListName:string; AReadOnly:boolean);
begin
  inherited Init(Bounds);
  Options := Options or (ofSelectable + ofFirstClick + ofVersion20);
  EventMask:=EventMask or evBroadcast;
  State := State or sfCursorVis;
  SetCursor(1,0);
  DataSourse:=ADataSourse;
  LookupSourse:=ALookupSourse;
  if DataSourse<>nil then DataField:=DataSourse^.FieldByName(ASName);
  if LookupSourse<>nil then
  begin
     LookupField:=LookupSourse^.FieldByName(ALName);
     LookupDisplay:=LookupSourse^.FieldByName(ARName);
  end;

  if (LookupField<>nil) and (DataField<>nil) then
  begin
    LookupSourse^.SetKey;
    LookupField^.Assign(DataField);
    LookupSourse^.GotoKeyEx;
  end;
  ComponentType:=ctDBLookupCombo;
  DataFieldName:=NewStr(ASName);
  LookupFieldName:=NewStr(ALName);
  LookupDisplayName:=NewStr(ARName);
  DisplayListName:=NewStr(ADisplayListName);
  ReadOnly:=AReadOnly;
  if ReadOnly then
     Options:=Options and (not ofSelectable);
end;

destructor TDBLookupCombo.Done;
begin
  inherited Done;
  DisposeStr(DataFieldName);
  DisposeStr(LookupFieldName);
  DisposeStr(LookupDisplayName);
  DisposeStr(DisplayListName);
end;

procedure TDBLookupCombo.HandleEvent(var Event:TEvent);
procedure ReReadBase;
begin
  if (Event.InfoPtr=DataSourse) and (DataFieldName<>nil) then
     DataField:=DataSourse^.FieldByName(DataFieldName^)
  else
  if Event.InfoPtr=LookupSourse then
  begin
    if LookupFieldName<>nil then LookupField:=LookupSourse^.FieldByName(LookupFieldName^);
    if LookupDisplayName<>nil then LookupDisplay:=LookupSourse^.FieldByName(LookupDisplayName^);
  end;
end;

procedure DestroyLinks;
begin
  if Event.InfoPtr=DataSourse then
  begin
    DataSourse:=nil;
    DataField:=nil;
  end;
  if Event.InfoPtr=LookupSourse then
  begin
    LookupSourse:=nil;
    LookupField:=nil;
    LookupDisplay:=nil;
  end;
end;
begin
  inherited HandleEvent(Event);
  case Event.What of
  evMouseDown,
  evKeyDown:
       if ((CtrlToArrow(Event.KeyCode)=kbDown) or (Event.What=evMouseDown))
          and (not ReadOnly) then
       begin
          CloseUp;
          DrawView;
       end
       else exit;
  evBroadcast:
    begin
      case Event.Command of
        cmNewTable:ReReadBase;
        cmUpDataDS:if Event.InfoPtr=DataSourse then DrawView;
        cmDestroed:DestroyLinks;
      end;
      exit;
    end;
  else
    exit;
  end;
  ClearEvent(Event);
end;

procedure TDBLookupCombo.Draw;
var
  B: TDrawBuffer;
  C:byte;
  S:String;
begin
  if ReadOnly then C:=4 else C:=1;
  MoveChar(B, ' ', GetColor(C), Size.X);
  if (DataField<>nil) and (LookupField<>nil) and
     (LookupDisplay<>nil) and (LockFlag=0) then
  begin
    LookupSourse^.SetKey;
    LookupField^.Assign(DataField);
    LookupSourse^.FindKeyEx;
{    GotoKeyEx;}
    if LookupSourse^.DSStatus<>dsNotFind then
      S:=copy(LookupDisplay^.DisplayText,1,MaxViewWidth-1)
    else S:='';
    MoveStr(B[1], S, GetColor(C))
  end
  else
  if ComponentName<>nil then MoveStr(B[1], ComponentName^, GetColor(C));
  if not ReadOnly then
     MoveCStr(B[Size.X-3], #222'~'#25'~'#221, GetColor($0203));
  WriteLine(0, 0, Size.X, Size.Y, B);
  SetCursor(0, 0);
end;

function TDBLookupCombo.GetPalette: PPalette;
begin
  GetPalette := @PalDBLookupCombo;
end;

procedure LUDBGridEvent(Sender:PView;var Event:TEvent;EventTime:TEventTime);far;
begin
  if ((Event.What=evBroadcast) and (Event.Command=cmDBGridSelect)) or
     ((Event.What=evKeyDown) and (Event.KeyCode=kbEnter)) then
  begin
    Sender^.ClearEvent(Event);
    Sender^.EndModal(cmOk);
  end
  else
  if ((Event.What=evKeyDown) and (Event.KeyCode=kbEsc)) then
  begin
    Sender^.ClearEvent(Event);
    Sender^.EndModal(cmCancel);
  end
end;

procedure TDBLookupCombo.CloseUp;
var
  P:PForm;
  DataScroller:PDataScroller;
  RR, R: TRect;
  TP:TPoint;
  DBGrid:PDBGrid;
  DBGridField:PDBGridField;
begin
  if LookupField=nil then exit;
  GetBounds(R);
  Owner^.MakeGlobal(R.A, TP);
  R.Assign(TP.X,TP.Y-1, TP.X+Size.X, TP.Y+7);
  Application^.GetExtent(RR);
  R.Intersect(RR);
  P:= New(PForm, Init(R, ''));
  P^.Flags := wfClose;
  P^.GetExtent(R);
  R.Grow(0,-1);
  R.A.X:=R.B.X-1;
  DataScroller:=New(PDataScroller, Init(R,LookupSourse));
  P^.Insert(DataScroller);
  P^.GetExtent(R);
  R.Grow(-1,-1);
  DBGrid:=New(PDBGrid,Init(R, nil, LookupSourse, DataScroller));
  DBGrid^.OnBroadcastEvent:={$IFNDEF FPC}LUDBGridEvent;{$ELSE}@LUDBGridEvent;{$ENDIF}
  DBGrid^.OnKeyEvent:={$IFNDEF FPC}LUDBGridEvent;{$ELSE}@LUDBGridEvent;{$ENDIF}
  DBGrid^.FieldDefs^.FreeAll;
  DBGridField:=New(PDBGridField, Init(DBGrid, LookupDisplay));
  DBGrid^.FieldDefs^.Insert(DBGridField);
  if DisplayListName<>nil then DBGridField^.SetTitle(DisplayListName^);
  P^.Insert(DBGrid);
  P^.HelpCtx := HelpCtx;
  Lock;
  if Application^.ExecView(P)=cmOk then DataField^.Assign(LookupField);
  UnLock;
  Select;
  P^.Free;
end;

constructor TDBLookupCombo.Load(var S:TStream);
begin
  inherited Load(S);
  DataFieldName:=S.ReadStr;
  LookupFieldName:=S.ReadStr;
  LookupDisplayName:=S.ReadStr;
  DisplayListName:=S.ReadStr;
  GetPeerViewPtr(S, DataSourse);
  GetPeerViewPtr(S, LookupSourse);
  S.Read(ReadOnly, SizeOf(Boolean));
end;

procedure TDBLookupCombo.Store(var S:TStream);
begin
  inherited Store(S);
  S.WriteStr(DataFieldName);
  S.WriteStr(LookupFieldName);
  S.WriteStr(LookupDisplayName);
  S.WriteStr(DisplayListName);
  PutPeerViewPtr(S, DataSourse);
  PutPeerViewPtr(S, LookupSourse);
  S.Write(ReadOnly, SizeOf(Boolean));
end;

procedure TDBLookupCombo.Lock;
begin
  Inc(LockFlag);
end;

procedure TDBLookupCombo.UnLock;
begin
  dec(LockFlag);
  if LockFlag=0 then DrawView;
end;

  {TDBText}
constructor TDBText.Init(Bounds:TRect; ADS:PDataSourse; Name:String);
begin
  inherited Init(Bounds, Name);
  EventMask:=EventMask or evBroadcast;
  DS:=ADS;
  if DS<>nil then
  begin
    Field:=DS^.FieldByName(Name);
    FieldName:=NewStr(Name);
  end;
  ComponentType:=ctDBText;
end;

destructor TDBText.Done;
begin
  inherited Done;
  DisposeStr(FieldName);
end;

procedure TDBText.GetText(var S: String);
begin
  if Field<>nil then
  begin
     S:=Field^.DisplayText;
     if Field^.Align = alRight then S:=^R+S
     else
     if Field^.Align=alCenter then S:=^C+S
  end
  else inherited GetText(S);
end;

procedure TDBText.HandleEvent(var Event:TEvent);
procedure AfterLoad;
var P:PString;
begin
  P:=PString(DS);
  if stUpCase(P^)<>stUpCase(PDataSourse(Event.InfoPtr)^.TableName^) then exit;
  DisposeStr(P);
  DS:=Event.InfoPtr;
end;
begin
  inherited HandleEvent(Event);
  if (Event.What=evBroadcast) then
    if (DS<>nil) and (Event.Command=cmAfterLoadDS) then
       AfterLoad
    else
    if (DS<>nil) and (Event.InfoPtr=DS) then
    begin
      case Event.Command of
        cmUpDataDS,
        cmAfterPost: DrawView;
        cmNewTable: if DS^.Active and (FieldName<>nil) then
                       Field:=DS^.FieldByName(FieldName^)
                    else Field:=nil;
        cmDestroed: begin
                      DS:=nil;
                      Field:=nil;
                    end;
      else
        Exit;
      end;
      DrawView;
    end;
end;

constructor TDBText.Load(var S:TStream);
begin
  inherited Load(S);
  FieldName:=S.ReadStr;
  PString(DS):=S.ReadStr;
  S.Read(DisplayType, SizeOf(TDisplayType));
end;

procedure TDBText.Store(var S:TStream);
var P:PString;
begin
  inherited Store(S);
  S.WriteStr(FieldName);
  if DS=nil then P:=nil
  else P:=DS^.TableName;
  S.WriteStr(P);
  S.Write(DisplayType, SizeOf(TDisplayType));
end;

  { TDBEdit }
constructor TDBEdit.Init(var Bounds:TRect; ADS:PDataSourse; Name:string);
begin
  inherited Init(Bounds, 255);
  EventMask:=EventMask or evBroadcast;
  Options:=Options or ofValidate;
  ComponentType:=ctDBEdit;
  FieldName:=NewStr(Name);
  ConectBase(ADS,Name);
end;

procedure TDBEdit.ConectBase(ADS:PDataSourse; Name:string);
begin
  DS:=ADS;
  if ADS<>nil then
  begin
    Field:=DS^.FieldByName(Name);
    if Field^.FieldType in [ftDate,ftDateTime] then
       SetValidator(New(PDateValidatorEx, Init('!',true)));
  end;
  UpData;
end;

destructor TDBEdit.Done;
begin
  inherited Done;
  DisposeStr(FieldName);
end;

procedure TDBEdit.HandleEvent(var Event:TEvent);
begin
  inherited HandleEvent(Event);
  if (Event.What = evBroadcast) and (Event.InfoPtr=DS) then
  case Event.Command of
    cmUpDataDS:UpData;
    cmNewTable:if (DS<>nil) then
               begin
                  if DS^.Active then Field:=DS^.FieldByName(FieldName^)
                  else Field:=nil;
                  UpData;
               end;
    cmDestroed:begin
                 DS:=nil;
                 Field:=nil;
               end;
  else
    exit;
  end;
end;

procedure TDBEdit.UpData;
begin
  if Field<>nil then
  begin
    if Field^.FieldType in [ftDate,ftDateTime] then
       Data^:=Trim(Field^.AsString)
    else {Data^:=Field^.AsString}
    Data^:=Field^.DisplayText;
  end
  else Data^:='';
  SelectAll(true);
  DrawView;
end;

procedure TDBEdit.SetState(AState: Word; Enable: Boolean);
begin
  if (Field<>nil) and (AState and (sfSelected+sfVisible) <> 0)
     and (Data<>nil) then
     if Enable then
     begin
       if Field^.FieldType in [ftDate,ftDateTime] then
          Data^:=Trim(Field^.AsString)
       else Data^:=Field^.AsString;
       SelectAll(True);
     end
     else
     begin
       if (State and sfVisible <> 0) and (DS^.DSState<>dsBrowse)
          and (Field^.AsString<>Data^) and  Field^.IsValidValue(Data^) and
          not DesignTime then
            Field^.SetAsString(Data^);
       Data^:=Field^.AsString
     end;
  inherited SetState(AState, Enable);
end;

procedure TDBEdit.Draw;
var
  Color: Byte;
  B: TDrawBuffer;
  S:string;
begin
  if (DS<>nil) and (Field<>nil) and DS^.Active then
    if State and sfFocused<>0 then
       inherited Draw
    else
    begin
      Color := GetColor(1);
      if (State and sfSelected)<>0 then
        S:=MakeAlign( Field^.Align, Data^, Size.X-2)
      else S:=MakeAlign( Field^.Align, Field^.DisplayText, Size.X-2);
      MoveChar(B, ' ', Color, Size.X);
      MoveStr(B[1], S, Color);
      WriteLine(0, 0, Size.X, Size.Y, B);
    end
  else
  begin
    if FieldName<>nil then S:=FieldName^
    else
    if ComponentName<>nil then S:=ComponentName^
    else S:='';
    if State and sfFocused = 0 then
      Color := GetColor(1) else
      Color := GetColor(2);
    MoveChar(B, ' ', Color, Size.X);
    MoveStr(B[1], S, Color);
    WriteLine(0, 0, Size.X, Size.Y, B);
  end;
end;

constructor TDBEdit.Load(var S:TStream);
begin
  inherited Load(S);
  FieldName:=S.ReadStr;
  GetPeerViewPtr(S, DS);
end;

procedure TDBEdit.Store(var S:TStream);
begin
  inherited Store(S);
  S.WriteStr(FieldName);
  PutPeerViewPtr(S, DS);
end;

function TDBEdit.Valid(Command: Word): Boolean;
var A:array [1..2] of Pointer;
begin
  Valid:=false;
  if not inherited Valid(Command) then exit;
  if (State and sfVisible <> 0) and (Field<>nil) and DS^.Active then
   if (Command=cmOk) or (Command=cmReleasedFocus) then
   begin
     if Data^<>'' then
     begin
       if (Field^.AsString<>TrimRight(Data^)) and not DesignTime then
         if not Field^.IsValidValue(Data^) then
         begin
           Select;
           SelectAll(True);
           exit;
         end
         else Field^.SetAsString(Data^);
     end;
   end
   else
   if (Command=cmCancel) then
     if Field^.FieldType in [ftDate,ftDateTime] then Data^:=Trim(Field^.AsString)
     else Data^:=Field^.AsString;

  Valid:=true;
end;

function TDBEdit.DataSize: word;
begin
  DataSize:=0;
end;

procedure TDBEdit.GetData(var Rec);
begin
end;

procedure TDBEdit.SetData(var Rec);
begin
end;

  { TDBLockUpText }
constructor TDBLockUpText.Init(Bounds:TRect; ADS:PDataSourse; Name:String;
                     AItems:PSItem);
var A:PSItem;
begin
  inherited Init(Bounds, ADS, Name);
  Items:=New(PStrings, Init);
  while AItems<>nil do
  begin
    Items^.Insert(AItems^.Value);
    A:=AItems^.Next;
    Dispose(AItems);
    AItems:=A;
  end;
  ComponentType:=ctDBLockUpText;
  if Field<>nil then
    if not (Field^.FieldType in [ftInteger,ftSmallint,ftWord,ftBoolean]) then
    begin
      Dispose(Items, Done);
      fail;
    end;
end;

destructor TDBLockUpText.Done;
begin
  Dispose(Items, Done);
  inherited Done;
end;

constructor TDBLockUpText.Load(var S:TStream);
begin
  inherited Load(S);
  Items:=PStrings(S.Get);
end;

procedure TDBLockUpText.Store(var S:TStream);
begin
  inherited Store(S);
  S.Put(Items);
end;

procedure TDBLockUpText.GetText(var S: String);
var i:integer;
begin
  if Field<>nil then i:=Field^.AsInteger else i:=-1;
  if (i>-1) and (i<Items^.Count) then
  begin
    S:=Items^.Str(i);
    if Field^.Align = alRight then S:=^R+S
    else
    if Field^.Align=alCenter then S:=^C+S
  end
  else
  if DesignTime then S:=Text^ else s:='';
end;

  { TDBLookupEdit }
constructor TDBLookupEdit.Init(Bounds:TRect; ADS:PDataSourse; Name:String; AItems:PSItem);
begin
  inherited Init(Bounds, ADS, Name, AItems);
  Options:=Options or ofSelectable;
  State := State or sfCursorVis;
  ComponentType:=ctDBLookupEdit;
end;

procedure TDBLookupEdit.Draw;
var
  B: TDrawBuffer;
begin
  inherited Draw;
  MoveCStr(B, #222'~'#25'~'#221, GetColor($0203));
  WriteLine(Size.X-3, 0, Size.X, Size.Y, B);
end;

procedure TDBLookupEdit.HandleEvent(var Event:TEvent);
procedure InitLockUpWindow;
var
  P: PLockUpBox;
  Rec:TListBoxRec;
  R,RR:TRect;
  TP:TPoint;
begin
  GetBounds(R);
  Owner^.MakeGlobal(R.A, TP);
  R.Assign(TP.X,TP.Y-1, TP.X+Size.X, TP.Y+7);
  Application^.GetExtent(RR);
  R.Intersect(RR);
  P := New(PLockUpBox, Init(R, nil));
  P^.HelpCtx := HelpCtx;
  Rec.List:=Items;
  Rec.Selection:=Field^.AsInteger;
  P^.SetData(Rec);
  if Application^.ExecView(P) = cmOk then
  begin
    P^.GetData(Rec);
    Field^.SetAsInteger(Rec.Selection);
    DrawView;
    Message(Owner, evBroadcast, cmViewChanged, @Self);
  end;
  P^.Free;
end;

var
  D:TPoint;
begin
  inherited HandleEvent(Event);
  if (Field=nil) or (DS=nil) or not DS^.Active then exit;
  if (Event.What = evMouseDown) then
  begin
     MakeLocal(Event.Where, D);
     if ((D.X>Size.X-3) and (D.X<Size.X-1)) then
     begin
       InitLockUpWindow;
       ClearEvent(Event);
     end;
  end;
  if (Event.What = evKeyDown) then
    if (CtrlToArrow(Event.KeyCode)=kbDown) then
    begin
       InitLockUpWindow;
       ClearEvent(Event);
    end;
end;

function TDBLookupEdit.GetPalette: PPalette;
begin
  GetPalette := @PalDBLookupCombo;
end;

  { TDBCluster }
constructor TDBCluster.Init(Bounds:TRect; ADS:PDataSourse; Name:String;
                     AItems:PSItem; AReadOnly:Boolean);
begin
  inherited Init(Bounds, AItems);
  ReadOnly:=AReadOnly;
  EventMask:=EventMask or evBroadcast;
  DS:=ADS;
  if DS<>nil then
  begin
    Field:=DS^.FieldByName(Name);
    FieldName:=NewStr(Name);
  end;
  ComponentType:=ctDBCluster;
end;


destructor TDBCluster.Done;
begin
  DisposeStr(FieldName);
  inherited Done;
end;

constructor TDBCluster.Load(var S:TStream);
begin
  inherited Load(S);
  S.Read(ReadOnly, SizeOf(Boolean));
  FieldName:=S.ReadStr;
  PString(DS):=S.ReadStr;
end;

procedure TDBCluster.Store(var S:TStream);
var P:PString;
begin
  inherited Store(S);
  S.Write(ReadOnly, SizeOf(Boolean));
  S.WriteStr(FieldName);
  if DS=nil then P:=nil
  else P:=DS^.TableName;
  S.WriteStr(P);
end;

procedure TDBCluster.DBUpdate;
begin
  DrawView;
end;

procedure TDBCluster.HandleEvent(var Event:TEvent);
procedure AfterLoad;
var P:PString;
begin
  P:=PString(DS);
  if stUpCase(P^)<>stUpCase(PDataSourse(Event.InfoPtr)^.TableName^) then exit;
  DisposeStr(P);
  DS:=Event.InfoPtr;
end;
begin
  inherited HandleEvent(Event);
  if (DS<>nil) and (Event.What=evBroadcast) and
     (Event.Command=cmAfterLoadDS) then AfterLoad
  else
  if (DS<>nil) and (Event.What=evBroadcast) and (Event.InfoPtr=DS) then
  begin
    case Event.Command of
      cmDestroed: begin
                    DS:=nil;
                    Field:=nil;
                  end;
      cmUpDataDS: DBUpdate;
      cmNewTable: if FieldName<>nil then
                  Field:=DS^.FieldByName(FieldName^);
    else
      Exit;
    end;
    DrawView;
  end;
end;

  { TDBRadioButtons }
constructor TDBRadioButtons.Init(Bounds:TRect; ADS:PDataSourse; Name:String;
                     AItems:PSItem; AReadOnly:Boolean);
begin
  inherited Init(Bounds, ADS, Name, AItems, AReadOnly);
  ComponentType:=ctDBRadioButtons;
end;

procedure TDBRadioButtons.Draw;
const
  Button = ' ( ) ';
begin
  DrawMultiBox(Button, #32#7);
end;

function TDBRadioButtons.Mark(Item: Integer): Boolean;
var I:integer;
begin
  if Field<>nil then i:=Field^.AsInteger else i:=0;
  Mark := Item = i;
end;

procedure TDBRadioButtons.MovedTo(Item: Integer);
begin
  Value := Item;
end;

procedure TDBRadioButtons.Press(Item: Integer);
begin
  if ReadOnly or (Field=nil) then exit;
  Field^.SetAsInteger(Item);
end;

procedure TDBRadioButtons.SetData(var Rec);
begin
end;

  { TDBCheckBox }
constructor TDBCheckBox.Init(Bounds:TRect; ADS:PDataSourse; Name:String;
                     AItems:string; AReadOnly:Boolean;
                     AValueChecked,AValueUnchecked:String);
begin
  inherited Init(Bounds, ADS, Name, NewSItem(AItems,nil), AReadOnly);
  ValueChecked:=NewStr(AValueChecked);
  ValueUnchecked:=NewStr(AValueUnchecked);
  ComponentType:=ctDBCheckBox;
end;

destructor TDBCheckBox.Done;
begin
  DisposeStr(ValueChecked);
  DisposeStr(ValueUnchecked);
  inherited Done;
end;

constructor TDBCheckBox.Load(var S:TStream);
begin
  inherited Load(S);
  ValueChecked:=S.ReadStr;
  ValueUnchecked:=S.ReadStr;
end;

procedure TDBCheckBox.Store(var S:TStream);
begin
  inherited Store(S);
  S.WriteStr(ValueChecked);
  S.WriteStr(ValueUnchecked);
end;

procedure TDBCheckBox.Draw;
const
  Button = ' [ ] ';
begin
  DrawMultiBox(Button, ' X');
end;

function TDBCheckBox.Mark(Item: Integer): Boolean;
begin
  if (ValueChecked<>nil) and (Field<>nil) then
  Mark := pos(TrimRight(Field^.AsString),ValueChecked^)<>0
  else Mark:=false;
end;

procedure TDBCheckBox.Press(Item: Integer);
begin
  if ReadOnly or (Field=nil) then exit;
  if Mark(Item) then Field^.SetAsString(ValueUnChecked^)
  else Field^.SetAsString(ValueChecked^)
end;

procedure TDBCheckBox.DBUpdate;
var S:string;
begin
  if (ValueChecked<>nil) and (Field<>nil) and (ValueUnchecked<>nil) then
  begin
     S:=stUpCase(TrimRight(Field^.AsString));
    if (pos(S,ValueChecked^)<>0) or (Pos(s,ValueUnchecked^)<>0) then
       EnableMask:=-1
    else EnableMask:=0;
  end
  else EnableMask:=0;
  DrawView;
end;

  { TDBNavigatorBtn }
constructor TDBNavigatorBtn.Init(var Bounds: TRect; ATitle: TTitleStr; ACommand: Word;
                         AFlags: Byte; ADataSourse:PDataSourse);
begin
  inherited Init(Bounds, ATitle, ACommand, AFlags);
  DataSourse:=ADataSourse;
  ComponentType:=ctDBNavigatorBtn;
end;

constructor TDBNavigatorBtn.Load(var S:TStream);
begin
  inherited Load(S);
  GetPeerViewPtr(S,DataSourse)
end;

procedure TDBNavigatorBtn.Store(var S:TStream);
begin
  inherited Store(S);
  PutPeerViewPtr(S,DataSourse)
end;

procedure TDBNavigatorBtn.Press;
begin
  if DataSourse=nil then exit;
  Message(Owner, evBroadcast, cmRecordHistory, nil);
  Message(DataSourse, evCommand, Command, nil);
end;

procedure TDBNavigatorBtn.HandleEvent(var Event:TEvent);
begin
  inherited HandleEvent(Event);
  case Event.What of
    evBroadcast:
    case Event.Command of
      cmDestroed:DataSourse:=nil;
    else
      exit;
    end;
  else
    exit;
  end;
end;

  { TDBMemo }
constructor TDBMemo.Init(var Bounds: TRect;
      AHScrollBar, AVScrollBar: PScrollBar;
      AIndicator: PIndicator; ADS:PDataSourse; AName:string);
begin
  inherited Init(Bounds, AHScrollBar, AVScrollBar, AIndicator, 0);
  EventMask:=EventMask or evBroadcast;
  DataSourse:=ADS;
  if DataSourse<>nil then
  begin
    Field:=DataSourse^.FieldByName(AName);
    FieldName:=NewStr(AName);
  end;
  ComponentType:=ctDBMemo;
end;

function TDBMemo.GetPalette: PPalette;
const
  P: String[Length(CMemo)] = CMemo;
begin
  GetPalette := @P;
end;

procedure TDBMemo.HandleEvent(var Event: TEvent);
begin
  if (Event.What <> evKeyDown) or (Event.KeyCode <> kbTab) then
    inherited HandleEvent(Event);
  if (Event.What = evBroadcast) and (Event.InfoPtr=DataSourse) then
    case Event.Command of
      cmUpDataDS:UpData;
      cmNewTable: if DataSourse<>nil then
                begin
                  Field:=DataSourse^.FieldByName(FieldName^);
                  UpData;
                end;
      cmDestroed:begin
                   DataSourse:=nil;
                   Field:=nil;
                 end;
    else
      exit;
    end;
end;

procedure TDBMemo.DoneBuffer;
begin
  if Buffer <> nil then DisposeBuffer(Buffer);
end;

procedure TDBMemo.InitBuffer;
begin
  NewBuffer(Pointer(Buffer), $1000);
end;

function TDBMemo.SetBufSize(NewSize: Word): Boolean;
var
  N: Word;
{$IFDEF VIRTUALPASCAL}
  P: Pointer;
{$ENDIF}
begin
  SetBufSize := False;
  if NewSize = 0 then NewSize := $1000 else
    if NewSize > $F000 then NewSize := $FFF0 else
      NewSize := (NewSize + $0FFF) and $F000;
{$IFNDEF VIRTUALPASCAL}
  if NewSize <> BufSize then
  begin
    if NewSize > BufSize then
      if not SetBufferSize(Buffer, NewSize) then Exit;
    N := BufLen - CurPtr + DelCount;
    Move(Buffer^[BufSize - N], Buffer^[NewSize - N], N);
    if NewSize < BufSize then SetBufferSize(Buffer, NewSize);
    BufSize := NewSize;
    GapLen := BufSize - BufLen;
  end;
{$ELSE}
  if NewSize <> BufSize then
  begin
    if NewSize > BufSize then
    begin
      P := MemAlloc(NewSize);
      if P = nil then Exit;
      Move(Buffer^, P^, BufSize);
      FreeMem(Buffer, BufSize);
      Buffer := P;
    end;
    N := BufLen - CurPtr + DelCount;
    Move(Buffer^[BufSize - N], Buffer^[NewSize - N], N);
    if NewSize < BufSize then
    begin
      P := MemAlloc(NewSize);
      if P = nil then NewSize := BufSize
     else
      begin
        Move(Buffer^, P^, BufSize);
        FreeMem(Buffer, BufSize);
        Buffer := P;
      end;
    end;
    BufSize := NewSize;
    GapLen := BufSize - BufLen;
  end;
{$ENDIF}
  SetBufSize := True;
end;

constructor TDBMemo.Load(var S:TStream);
begin
  inherited Load(S);
  FieldName:=S.ReadStr;
  GetPeerViewPtr(S, DataSourse);
end;

procedure TDBMemo.Store(var S:TStream);
begin
  inherited Store(S);
  S.WriteStr(FieldName);
  PutPeerViewPtr(S, DataSourse);
end;

procedure TDBMemo.UpData;
var
  Data:PMemoRec;
  S:word;
begin
  if Field<>nil then
  begin
    S:=Field^.GetSize;
    SetBufSize(S);
    GetMem(Data, S+SizeOf(word));
    Field^.GetData(Data^);
    Move(Data^.Text, Buffer^[BufSize - S], S);
    FreeMem(Data, S+SizeOf(word));
    SetBufLen(S);
  end;
end;

procedure TDBMemo.SaveToBase;
var
  Data:PMemoRec;
begin
  if Modified and (Field<>nil) then
  begin
    GetMem(Data, BufLen+SizeOf(word));
    Data^.Length:=BufLen;
    Move(Buffer^, Data^.Text, CurPtr);
    Move(Buffer^[CurPtr + GapLen], Data^.Text[CurPtr], BufLen - CurPtr);
    Field^.SetData(Data^);
    FreeMem(Data, BufLen+SizeOf(word));
  end;
end;

procedure TDBMemo.SetState(AState: Word; Enable: Boolean);
begin
  if (Field<>nil) and (AState and sfExposed <> 0) then
     if not ((DataSourse^.DSState in [dsBrowse,dsCreate]) or DesignTime) then
     if Enable then
        UpData
     else SaveToBase;
  inherited SetState(AState, Enable);
end;

  { TDBDateEdit }
constructor TDBDateEdit.Init(var Bounds:TRect; ADS:PDataSourse; Name:string);
begin
  inherited Init(Bounds, ADS, Name);
  SetValidator(New(PDateValidatorEx, Init('!',true)));
  ComponentType:=ctDBDateEdit;
end;


constructor TDBDateEdit.Load(var S:TStream);
begin
  inherited Load(S);
  S.Read(DefaultToday, SizeOf(Boolean));
end;

procedure TDBDateEdit.Store(var S:TStream);
begin
  inherited Store(S);
  S.Write(DefaultToday, SizeOf(Boolean));
end;

procedure TDBDateEdit.Draw;
var
  B: TDrawBuffer;
  L:integer;
begin
  L:=Size.X;
  Dec(Size.X,3);
  inherited Draw;
  Size.X:=L;
  MoveCStr(B, #222'~'#25'~'#221, GetColor($0506));
  WriteLine(Size.X-3, 0, Size.X, Size.Y, B);
end;

procedure TDBDateEdit.HandleEvent(var Event:TEvent);
var
  CalenPanel: PCalenPanel;
  Mouse: TPoint;
  R,P:TRect;
begin
  MakeLocal(Event.Where, Mouse);
  if ((Event.What = evMouseDown) and (Mouse.X>Size.X-4)) or
     ((Event.What = evKeyDown) and (CtrlToArrow(Event.KeyCode) = kbDown)) then
  begin
    GetBounds(R);
    Inc(R.A.Y); R.B.X:=R.A.X+25; R.B.Y:=R.A.Y+9;
    Owner^.GetExtent(P);
    R.Intersect(P);
    Dec(R.B.Y,1);
    if R.B.X-R.A.X<25 then R.A.X:=R.B.X-25;
    if R.B.Y-R.A.Y<9 then R.A.Y:=R.B.Y-8;
    CalenPanel := InitCalendarPicWindow(R, @Self, StrToDate(Data^));
    if CalenPanel <> nil then
    begin
      if Owner^.ExecView(CalenPanel) = cmOk then
      begin
         Data^ := Trim(DateToStr(CalenPanel^.Date));
         SelectAll(true);
         DrawView;
      end;
      Select;
      Dispose(CalenPanel, Done);
    end;
    ClearEvent(Event);
    exit;
  end;
  inherited HandleEvent(Event);
end;

function TDBDateEdit.GetPalette: PPalette;
begin
  GetPalette := @PalDBLookupCombo;
end;

procedure RegisterDBCtrls;
begin
  RegisterType(RDBLookupCombo);
  RegisterType(RDBText);
  RegisterType(RDBEdit);
  RegisterType(RDBLockUpText);
  RegisterType(RDBRadioButtons);
  RegisterType(RDBCheckBox);
  RegisterType(RDBLookupEdit);
  RegisterType(RDBNavigatorBtn);
  RegisterType(RDBMemo);
  RegisterType(RDBDateEdit);
end;
end.
