{************************************************}
{                                                }
{   Turbo Pascal 7.0                             }
{   FreePacal                                    }
{   Delphi 4                                     }
{   Grid & String grid                           }
{   Copyright (c) 1995,96,97 by Alexs            }
{                                                }
{************************************************}

{$IFDEF VER70}
{$O+}
{$ENDIF}

{$I Define.inc}
unit Grids;
interface

uses Objects, Drivers, Views, Dialogs, Validate, Ext_Type, Register,
     Ext_Edit, Ext_Sys;

const
{  MouseAutosToSkip:integer = 1;}
  DefWidthCollumn:Integer  = 10;
const
  CDrawGrid    = #6#16#4;

const
  ufUpdate   = $0001;
  ufView     = $0002;
  ufOneLine  = $0004;
  ufTwoLine  = $0008;
  ufThreLine = $000C;
  ufLine     = $0010;
  ufInfoPane = $0020;


const
  sdDataError     = 1;
  sdSaveAs        = 2;
  sdSaveError     = 3;
  sdSaveUntitled  = 4;
  sdSaveModify    = 5;
  sdLoadAs        = 6;

const
  grAutoCalc           = $01;
  grEdit               = $02;
  grNotEdit            = $04;
  grAutoSize           = $08;
  dgAlwaysShowEditor   = $10;

  smExtend = $01;
const
  CGridInputLine    = #1#6#7#3;

type
   PGridInputLine = ^TGridInputLine;
   TGridInputLine = object(TInputLine)
     constructor Init(var Bounds:TRect; AMaxLen:byte);
     function GetPalette: PPalette; virtual;
     procedure HandleEvent(var Event:TEvent);virtual;
   end;

type
   PDrawGrid = ^TDrawGrid;
   TDrawGridEdit = function(Sender:PDrawGrid;var Rect:TRect; var S:String):word;
   {if Y<0 㥬 ਧ⠫   ⨪}
   TDrawGridDrawTitle = procedure(Sender:PDrawGrid; Y:integer; Color:word; var B:TDrawBuffer);
   TWidthCollumnEvent = function(Sender:PDrawGrid; Y:integer):integer;
   TDrawGridGetTextEvent = function(Sender:PDrawGrid; Col,Rov:Word; MaxLen:byte;
                                                      DisplayText:Boolean):string;
   TDrawGridSetValueEvent = function (Sender:PDrawGrid; APos:TPoint;var Str:String):boolean;
   TDrawGridGetAlign = function(Sender:PDrawGrid; const X,Y:word):TAlign;
   TDrawGridSetAlign = procedure(Sender:PDrawGrid; const X,Y:word;const aAlign:TAlign);
   TDrawGridEditing = function (Sender:PDrawGrid;  X,Y:word):boolean;

   TDrawGrid = object(TView)
      VScrollBar: PScrollBar;
      HScrollBar: PScrollBar;
      Indicator: PExtIndicator;
      CurPos: TPoint;
      Delta: TPoint;
      Limit: TPoint;
      SelectStart: TPoint;
      SelectEnd: TPoint;
      Selecting: Boolean;
      DrawLine: Integer;
      Modified: Boolean;
      ScrollMode:Char;
      grOptions:byte;
      WidthTitle:integer;
      Validator:PValidator;
      constructor Init(var Bounds: TRect; AHScrollBar, AVScrollBar:PScrollBar; AIndicator: PExtIndicator);
      constructor Load(var S:TStream);
      function CursorVisible:boolean;
      function GetPalette: PPalette; virtual;
      function GetText(Col,Rov:Word; MaxLen:byte; DisplayText:Boolean):string; virtual;
      function GetValue(Col,Rov:Word; MaxLen:byte):string; virtual;
      function GetWidthCol( ACol:word):byte;virtual;
      procedure SetWidthCol( ACol:word; AWidth:integer);virtual;
      procedure Draw; virtual;
      procedure DrawInfoPane; virtual;
      procedure DrawLines(Y, Count: Integer);
      procedure DrawTitle;virtual;
      procedure HandleEvent(var Event: TEvent); virtual;
      procedure LineDown;
      procedure LineLeft;
      procedure LineRight;
      procedure LineUp;
      procedure ScrollTo( X,Y:integer);
      procedure SetLimit(XMax,YMax:integer);
      procedure UpdateCommands; virtual;
      procedure SetSelect(SBeg,SEnd:TPoint);
      procedure Update(AMode:word);
      procedure Look;
      procedure UnLook;
      procedure Store(var S:TStream);
      function ContinueSelect:boolean;
      procedure HideSelect;
      procedure ShowSelect;
      function SetValue(APos:TPoint;var AStr:String):boolean;virtual;
      function ItsNull(const X,Y:word):boolean;virtual;
      procedure PutDate(const X,Y:word; var S:TStream);virtual;
      procedure GetDate(const X,Y:word; var S:TStream; AStatus:Boolean);virtual;
      function Align(const X,Y:word):TAlign;virtual;
      procedure SetAlign(const X,Y:word;const aAlign:TAlign);virtual;
      procedure ClipCopy;
      procedure ToggleAutoCalc;
      function Editing( X,Y:word):boolean;virtual;
      procedure FocusItem( X,Y: Integer); virtual;
      function RowCount:integer;
      function ColCount:integer;
      procedure SetState(AState: Word; Enable: Boolean); virtual;
   private
      SelectMode: Byte;
      EndSelecting:boolean;
      ASel:Boolean;
      LookFlag:Integer;
      UpdateFlags: word;
      procedure DoUpdate;
      procedure EditData;
   public
      OnDrawGridEdit:TDrawGridEdit;
      OnDrawGridDrawTitle:TDrawGridDrawTitle;
      OnWidthCollumnEvent:TWidthCollumnEvent;
      OnGetText:TDrawGridGetTextEvent;
      OnDrawGridSetValueEvent:TDrawGridSetValueEvent;
      OnDrawGridGetAlign:TDrawGridGetAlign;
      OnDrawGridSetAlign:TDrawGridSetAlign;
      OnEditing:TDrawGridEditing;
   end;

type
   PValue = ^TValue;
   TValue = object(TObject)
      Align:TAlign;
      constructor Init(ARow:longint; AValue:string);
      constructor Load(var S:TStream);
      procedure Store(var S:TStream);
      destructor Done;virtual;
      function AsString:string;
      function AsFloat:real;
      procedure SetAsString( AValue:String);
      procedure SetAsFloat( AVAlue:Real);
   private
      Row:longint;
      Value:PString;
   end;
type
   PCollumn = ^TCollumn;
   TCollumn = object(TSortedCollection)
      constructor Init(ACol:longint; AValue:PValue);
      constructor Load(var S:TStream);
      procedure Store(var S:TStream);
      function AsString(ARow:longint):string;
      function AsFloat(ARow:longint):real;
      procedure SetAsString(ARow:longint; AValue:String);
      procedure SetAsFloat(ARow:longint; AVAlue:Real);
      function Compare(Key1, Key2: Pointer): Integer; virtual;
      function KeyOf(Item: Pointer): Pointer; virtual;
   private
     Column:longint;
     Width:integer;
   end;

type
   PCollumnCollection = ^TCollumnCollection;
   TCollumnCollection = object(TSortedCollection)
      function AsString(ACol,ARow:longint):string;
      function AsFloat(ACol,ARow:longint):real;
      procedure SetAsString(ACol,ARow:longint; AValue:String);
      procedure SetAsFloat(ACol,ARow:longint; AVAlue:Real);
      function Compare(Key1, Key2: Pointer): Integer; virtual;
      function KeyOf(Item: Pointer): Pointer; virtual;
      function Width(Collumn:Longint):integer;
      procedure SetWidth(Collumn:Longint; AWidth:integer);
   end;

type
   PStringGrid = ^TStringGrid;
   TStringGrid = object(TDrawGrid)
      Strings:PCollumnCollection;
      constructor Init(var Bounds: TRect; AHScrollBar,
                           AVScrollBar:PScrollBar; AIndicator: PExtIndicator);
      constructor Load(var S:TStream);
      procedure Store(var S:TStream);
      destructor Done;virtual;
      function GetText(Col,Rov:Word; MaxLen:byte; DisplayText:Boolean):string; virtual;
      function SetValue(APos:TPoint;var AStr:String):boolean;virtual;
      procedure SaveFile(FileName:FNameStr);
      procedure LoadFile(FileName:FNameStr);
      procedure LoadAs;
      procedure SaveAs;
      procedure HandleEvent(var Event:TEvent);virtual;
      function GetWidthCol( ACol:word):byte;virtual;
      procedure SetWidthCol( ACol:word; AWidth:integer);virtual;
      function ItsNull(const X,Y:word):boolean;virtual;
      procedure PutDate(const X,Y:word; var S:TStream);virtual;
      procedure GetDate(const X,Y:word; var S:TStream; AStatus:Boolean);virtual;
      function Align(const X,Y:word):TAlign;virtual;
      procedure SetAlign(const X,Y:word;const aAlign:TAlign);virtual;
   end;

function IntToABC(AVal:Word):string;
function ABCToInt(S:String):word;

const
  RValue : TStreamRec = (
     ObjType: rcValue;
     VmtLink: Ofs(TypeOf(TValue )^);
     Load:    @TValue .Load;
     Store:   @TValue .Store
  );
const
  RCollumn: TStreamRec = (
     ObjType: rcCollumn;
     VmtLink: Ofs(TypeOf(TCollumn)^);
     Load:    @TCollumn.Load;
     Store:   @TCollumn.Store
  );
const
  RCollumnCollection: TStreamRec = (
     ObjType: rcCollumnCollection;
     VmtLink: Ofs(TypeOf(TCollumnCollection)^);
     Load:    @TCollumnCollection.Load;
     Store:   @TCollumnCollection.Store
  );
const
  RDrawGrid: TStreamRec = (
     ObjType: rcDrawGrid;
     VmtLink: Ofs(TypeOf(TDrawGrid)^);
     Load:    @TDrawGrid.Load;
     Store:   @TDrawGrid.Store
  );
const
  RStringGrid: TStreamRec = (
     ObjType: rcStringGrid;
     VmtLink: Ofs(TypeOf(TStringGrid)^);
     Load:    @TStringGrid.Load;
     Store:   @TStringGrid.Store
  );

{type
  TGridDialog = function(Dialog: Integer; Info: Pointer): Word;

function DefGridDialog(Dialog: Integer; Info: Pointer): Word;far;
function StdGridDialog(Dialog: Integer; Info: Pointer): Word;far;

const
  GridDialog: TGridDialog = stdGridDialog;
const
  CreateBak:Boolean = true;}

procedure RegisterGrids;

implementation
uses Ext_Math, MsgBox, App, StdDlg, Ext_Str, Ext_Dos, Clases;

function IntToABC(AVal:Word):string;
var
  S:String;
  j,i:byte;
begin
  i:= AVal mod 26;
  j:=4;
  S:='    '+Char(i+65);
  AVal:= AVal div 26;
  while AVal<>0 do
  begin
    i:= AVal mod 26;
    S[j]:=Char(i+64);
    AVal:= Aval div 26;
    Dec(j);
  end;
  IntToABC:=S;
end;

function ABCToInt(S:String):word;
var
  j:byte;
  k:word;
begin
  ABCToInt:=0;
  S:=StUpCase(Trim(S));
  if S='' then exit;
  j:=1;k:=0;
  while j<byte(s[0]) do
  begin
    k:=k*26+byte(S[j])-64;
    inc(j);
  end;
  ABCToInt:=k*26+byte(s[j])-65;
end;


function DefGridDialog(Dialog: Integer; Info: Pointer): Word;
begin
  DefGridDialog:=cmCancel;
end;

function StdGridDialog(Dialog: Integer; Info: Pointer): Word;
begin
  case Dialog of
    sdSaveError:MessageBox('訡  䠩 %s!',Info, mfError+mfOkButton);
    sdSaveModify:
      StdGridDialog := MessageBox('%s has been modified. Save?',
        @Info, mfInformation + mfYesNoCancel);
    sdSaveUntitled:
      StdGridDialog := MessageBox('Save untitled file?',
        nil, mfInformation + mfYesNoCancel);
    sdSaveAs:
      StdGridDialog :=
        Application^.ExecuteDialog(New(PFileDialog, Init('*.cht',
        'Save file as', '~N~ame', fdOkButton, 101)), Info);
    sdLoadAs:
      StdGridDialog :=
        Application^.ExecuteDialog(New(PFileDialog, Init('*.cht',
        'Load file as', '~N~ame', fdOpenButton, 101)), Info);
  end;
end;

  {TGridInputLine}
constructor TGridInputLine.Init(var Bounds:TRect; AMaxLen:byte);
begin
  inherited Init( Bounds, AMaxLen);
  ComponentType:=ctGridInputLine;
end;

function TGridInputLine.GetPalette: PPalette;
const
  P: String[Length(CGridInputLine)] = CGridInputLine;
begin
  GetPalette := @P;
end;

procedure TGridInputLine.HandleEvent(var Event:TEvent);
{var
  Mouse: TPoint;}
begin
  inherited HandleEvent(Event);
  case Event.What of
    evKeyDown:
    case Event.KeyCode of
        kbUp:EndModal(cmYes);
        kbDown:EndModal(cmNo);
        kbPgDn:EndModal(cmYes);
        kbPgUp:EndModal(cmNo);
    else
        exit;
    end;
  else
    exit;
  end;
  ClearEvent(Event);
end;

  {TDrawGrid}
constructor TDrawGrid.Init(var Bounds: TRect; AHScrollBar, AVScrollBar:
                PScrollBar; AIndicator: PExtIndicator);
begin
  inherited Init(Bounds);
  GrowMode := gfGrowHiX + gfGrowHiY;
  Options := Options or ofSelectable;
  EventMask := evMouseDown + evKeyDown + evCommand + evBroadcast;
  WidthTitle:=5;
  HScrollBar := AHScrollBar;
  VScrollBar := AVScrollBar;
  Indicator := AIndicator;
  ScrollMode:=#25;
  grOptions := grOptions or grAutoCalc;
  UpDate(ufView);
  ComponentType:=ctDrawGrid;
end;

constructor TDrawGrid.Load(var S:TStream);
begin
  inherited Load(S);
  GetPeerViewPtr(S, HScrollBar);
  GetPeerViewPtr(S, VScrollBar);
  GetPeerViewPtr(S, Indicator);
  S.Read(CurPos, SizeOf(TPoint)*5+SizeOf(Boolean));
  S.Read(ScrollMode, SizeOf(Char)+SizeOf(Byte));
  S.Read(WidthTitle, SizeOf(integer));
  Validator:=PValidator(S.Get);
{$IFDEF VER70}
  LoadProcedure(S, @OnDrawGridEdit);
  LoadProcedure(S, @OnDrawGridDrawTitle);
  LoadProcedure(S, @OnWidthCollumnEvent);
  LoadProcedure(S, @OnGetText);
  LoadProcedure(S, @OnDrawGridSetValueEvent);
{$ENDIF}
end;

procedure TDrawGrid.SetLimit(XMax,YMax:integer);
begin
  Limit.X:=XMax-1;
  Limit.Y:=YMax-1;
  Update(ufView);
end;

procedure TDrawGrid.SetWidthCol( ACol:word; AWidth:integer);
begin
end;

function TDrawGrid.GetWidthCol( ACol:word):byte;
begin
  if Assigned(OnWidthCollumnEvent) then
     GetWidthCol:=OnWidthCollumnEvent(@Self, ACol)
  else
     GetWidthCol:=DefWidthCollumn;
end;


procedure TDrawGrid.DoUpdate;
begin
  if UpdateFlags <> 0 then
  begin
    LookFlag:=-1;
    if UpdateFlags and ufView <> 0 then DrawView else
       if UpdateFlags and ufLine <> 0 then DrawLines( 0, Size.Y-2) else
       if UpdateFlags and ufThreLine <> 0 then
          DrawLines( CurPos.Y-delta.Y, ((UpdateFlags and ufThreLine) shr 2) and $03) else
          if UpdateFlags and ufInfoPane <> 0 then DrawInfoPane;
    if HScrollBar <> nil then
      HScrollBar^.SetParams(CurPos.X, 0, Limit.X, Size.X div (GetWidthCol(CurPos.X) * 2), 1);
    if VScrollBar <> nil then
      VScrollBar^.SetParams(CurPos.Y, 0, Limit.Y - Size.Y, Size.Y - 1, 1);
{    if Indicator <> nil then Indicator^.SetValue(CurPos, Modified);}
    if State and sfActive <> 0 then UpdateCommands;
    UpdateFlags := 0;
    LookFlag:=0;
    if grOptions and dgAlwaysShowEditor <> 0 then
    begin
    end;
  end;
end;

procedure TDrawGrid.Draw;
begin
  DrawTitle;
  DrawLines(0,Size.Y-2);
end;

procedure TDrawGrid.DrawInfoPane;
var
  Color: Byte;
  B: TDrawBuffer;
  S:String[5];
  Par:array[1..5] of longint;
begin
  FillChar( Par, SizeOf(Par), #0);
  if grOptions and grAutoCalc <>0 then Par[1]:=65;
  Par[2]:=byte(ScrollMode);
  if Selecting then Par[3]:=83;
  if grOptions and grEdit <>0 then Par[4]:=69;
  FormatStr(S,' %c%c%c%c',Par);
  Color := GetColor(1);
  MoveChar(B, ' ', Color, WidthTitle);
  MoveStr(B, S, Color);
  WriteLine(0, 0, WidthTitle, 1, B);
end;

{$IFDEF VER70}
procedure DoMoveStr(var Dest; const Str: String); assembler;
asm
        MOV     DX,DS
        LDS     SI,Str
        CLD
        LODSB
        MOV     CL,AL
        XOR     CH,CH
        JCXZ    @@4
        LES     DI,Dest
@@1:    LODSB
        STOSB
        INC     DI
        LOOP    @@1
        JMP     @@4
@@4:    MOV     DS,DX
end;

procedure DoDrawPane(var BB; Size:Byte; Color:byte);assembler;
asm
   LES  DI,BB
   XOR  CX,CX
   MOV  CL,Size
   MOV  AL,Color
@@1:
   INC  DI
   STOSB
   LOOP @@1
end;
{$ELSE}

procedure DoMoveStr(var Dest; const Str: String);
var B:TDrawBuffer absolute Dest;
    i:integer;
begin
  for i:=0 to Length(Str)-1 do WordRec(B[i]).Lo:=Byte(Str[i+1]);
end;

procedure DoDrawPane(var BB; Size:Byte; Color:byte);
var B:TDrawBuffer absolute BB;
    i:integer;
begin
  for i:=0 to Size-1 do WordRec(B[i]).Hi:=Color;
end;
{$ENDIF}

procedure TDrawGrid.DrawLines(Y, Count: Integer);
var
  Color, SelColor, NormalColor, CursorColor: Byte;
  B: TDrawBuffer;
  S:string;
  i,j,l:integer;
  CellWidth, SizeWorkArea:Integer;

function FormatCell(CellLen:byte; aAlign:TAlign; S:string; MaxLen:byte):string;
begin
  if (Length(S)>MaxLen) then byte(s[0]):=MaxLen
  else
  begin
    case aAlign of
      alCenter:S:=DupChar(' ',(CellLen - Length(S)) shr 1)+S;
      alRight:S:=DupChar(' ',CellLen-Length(S))+S;
    end;
    if S<>'' then
       if Length(s)<MaxLen then S:=S+DupChar(' ',MaxLen-Length(S));
  end;
  FormatCell:=S;
end;



begin
  DrawInfoPane;
  SelColor:=GetColor(2);
  NormalColor:=GetColor(1);
  CursorColor:=GetColor(3);
  SizeWorkArea:=Size.X-WidthTitle;
  for j:=Y to Y+Count do
  begin
    L:=Delta.X;
    MoveChar(B, ' ', NormalColor, Size.X);
    if (CurPos.Y=j+Delta.Y) then
    begin           {㥬 }
       CellWidth:=0;
       for i:=Delta.X to CurPos.X-1 do inc(CellWidth,GetWidthCol(i));
       DoDrawPane(B[CellWidth],GetWidthCol(CurPos.X), CursorColor);
    end;
    i:=0;
    while i<SizeWorkArea do
    begin
      CellWidth:=GetWidthCol(l);
       if (CurPos.X<>l) or (CurPos.Y<>j+Delta.Y) then
       if Selecting and ((L>=SelectStart.X) and (L<=SelectEnd.X) and
            (j+Delta.Y>=SelectStart.Y) and (j+Delta.Y<=SelectEnd.Y)) then
            DoDrawPane(B[i],CellWidth,SelColor);
      if (L<=Limit.X) and (j+Delta.Y<=Limit.Y) then
      begin
         S:=GetText(l,j+Delta.Y, SizeWorkArea-i, true);
         if S<>'' then
         begin
           S:=FormatCell(CellWidth, Align(l,j+Delta.Y), S, SizeWorkArea-i);
           DoMoveStr(B[i], S);
         end;
      end;
      if L<=Limit.X then inc(i,CellWidth) else i:=Size.X;
      inc(l);
    end;
    WriteLine( WidthTitle, j+1, SizeWorkArea, 1, B);
  end;
end;


procedure TDrawGrid.DrawTitle;
var
  Color: Byte;
  B: TDrawBuffer;
  S:string;
  i:byte;
  L,WC:Longint;
begin
  if (State and (sfSelected + sfActive) = (sfSelected + sfActive))
     or (grOptions and grEdit<>0) then
    Color := GetColor(3)
  else Color := GetColor(1);
  MoveChar(B, ' ',Color,Size.X-WidthTitle);
  L:=Delta.X;
  i:=0;
  if Assigned(OnDrawGridDrawTitle) then
     OnDrawGridDrawTitle(@Self, -1, Color, B)
  else
  while i<Size.X do
  begin
    WC:=GetWidthCol(L);
    FormatStr(S,'%'+IntToStr(WC div 2+1)+'d',Pointer(L));
    MoveStr(B[i], S, Color);
    inc(i,WC);
    inc(l);
  end;
  WriteLine( WidthTitle, 0, Size.X-WidthTitle, 1, B);
  L:=Delta.Y;
  for i:=1 to Size.Y-1 do
  begin
    MoveChar(B, ' ', Color, WidthTitle);
    if Assigned(OnDrawGridDrawTitle) then
      OnDrawGridDrawTitle(@Self, i, Color,  B)
    else
    begin
      MoveStr(B, IntToABC(L), Color);
      Inc(l);
    end;
    WriteLine(0, i, WidthTitle, 1, B);
  end;
end;

function TDrawGrid.GetPalette: PPalette;
const
  P: String[Length(CDrawGrid)] = CDrawGrid;
begin
  GetPalette := @P;
end;

procedure TDrawGrid.ScrollTo( X,Y:integer);
begin
  Inc(Delta.X,X);
  Inc(Delta.Y,Y);
  Update(ufView);
end;

procedure TDrawGrid.LineUp;
begin
  ASel:=false;
  if SelectMode<>0 then ASel:=ContinueSelect;
  ScrollMode:=#24;
  if CurPos.Y<1 then Exit;
  Dec(CurPos.Y);
  if ASel then
     if EndSelecting then
        SetSelect( SelectStart, CurPos)
     else SetSelect( CurPos, SelectEnd);
  if CurPos.Y<Delta.Y then
     ScrollTo(0,-1)
  else
     UpDate(ufTwoLine);
end;

procedure TDrawGrid.LineDown;
begin
  ASel:=false;
  if SelectMode<>0 then ASel:=ContinueSelect;
  ScrollMode:=#25;
  if CurPos.Y>=Limit.Y then
     if grOptions and grAutoSize <> 0 then
        SetLimit(Limit.X+1,Limit.Y+2)
    else exit;
  inc(CurPos.Y);
  if ASel then
     if EndSelecting then
        SetSelect( SelectStart, CurPos)
     else SetSelect( CurPos, SelectEnd);
  if CurPos.Y>(Delta.Y+Size.Y-2) then
     ScrollTo(0,1)
  else
     UpDate(ufLine);
end;

procedure TDrawGrid.LineLeft;
begin
  ASel:=false;
  if SelectMode<>0 then ASel:=ContinueSelect;
  ScrollMode:=#27;
  if CurPos.X>0 then
  begin
    Dec(CurPos.X);
    if ASel then
       if EndSelecting then
          SetSelect( SelectStart, CurPos)
       else SetSelect( CurPos, SelectEnd);
    if CurPos.X<Delta.X then
       ScrollTo(-1,0)
    else
       UpDate(ufOneLine);
  end
end;

procedure TDrawGrid.LineRight;
var
  ii:byte;
  i:word;
begin
 ScrollMode:=#26;
 ASel:=false;
 if SelectMode<>0 then ASel:=ContinueSelect;
 if CurPos.X=Limit.X then
    if grOptions and grAutoSize <> 0 then inc(Limit.X)
    else exit;
 inc(CurPos.X);
 ii:=0;
 for i:=Delta.X to CurPos.X do
    inc(ii,GetWidthCol(i));
 if ASel then
    if EndSelecting then
       SetSelect( SelectStart, CurPos)
    else SetSelect( CurPos, SelectEnd);
 if ii>(Size.X-WidthTitle) then
    ScrollTo(1,0)
 else
    Update(ufOneLine);
end;

procedure TDrawGrid.ToggleAutoCalc;
begin
  if grOptions and grAutoCalc<>0 then grOptions:=grOptions and not grAutoCalc
  else  grOptions := grOptions or grAutoCalc;
  UpDate(ufInfoPane);
end;

procedure TDrawGrid.HandleEvent(var Event: TEvent);
var
  {ShiftState: Byte absolute $40:$17;}
  OldItem:TPoint;
  Mouse: TPoint;
{  Count,}i,ii:integer;

procedure Home;
begin
  FillChar(CurPos, SizeOf(CurPos),0);
  FillChar(Delta, SizeOf(Delta),0);
  Update(ufView);
end;

procedure CheckScrollBar(P: PScrollBar; var D: Integer);
begin
  if (Event.InfoPtr = P) and (P^.Value <> D) then
  begin
    D := P^.Value;
    UpDate(ufView);
  end;
end;

procedure PgUp;
var I:integer;
begin
  for i:=1 to Size.Y-2 do LineUp;
end;

procedure PgDn;
var I:integer;
begin
  for i:=1 to Size.Y-2 do LineDown;
end;

procedure EndDoc;
begin
  Look;
  ScrollTo(0,Limit.Y-CurPos.Y-Size.Y+2);
  CurPos.Y:=Limit.Y;
  UnLook;
end;

procedure DestroyLinks;
begin
  if Event.InfoPtr=VScrollBar then VScrollBar:=nil;
  if Event.InfoPtr=HScrollBar then HScrollBar:=nil;
  if Event.InfoPtr=Indicator then Indicator:=nil;
end;

begin
  if GetShiftState and $03 <> 0 then SelectMode := smExtend
  else SelectMode:=0;
  inherited HandleEvent( Event);
  case Event.What of
    evMouseDown:
    begin
      MakeLocal(Event.Where, Mouse);
      if (MouseInView(Event.Where)) then
      if Event.Where.Y=2 then
      begin
        LineUp;
      end
      else
      if (Mouse.X>WidthTitle) then
      begin
          CurPos.Y := Mouse.Y-1+Delta.Y;
          if CurPos.Y>Limit.Y then
             if grOptions and grAutoSize <> 0 then inc(Limit.Y)
             else exit;
          i:=Delta.X;ii:=WidthTitle;
          while ii<Mouse.X do
          begin
             inc(ii,GetWidthCol(Delta.X+i));
             inc(i);
          end;
          if i-1<0 then CurPos.X:=0 else CurPos.X:=i-1;
          if CurPos.X>Limit.X then
             if grOptions and grAutoSize <> 0 then inc(Limit.X)
             else exit;
          UpDate(ufLine);
      end;
{      Count := 0;}
      repeat
          MakeLocal(Event.Where, Mouse);
          if (MouseInView(Event.Where)) and ( Mouse.Y<>0)
             and (Mouse.X>WidthTitle) then
          begin
             CurPos.Y := Mouse.Y-1+Delta.Y;
             if CurPos.Y>Limit.Y then
                if grOptions and grAutoSize <> 0 then inc(Limit.Y)
                else exit;
             i:=Delta.X;ii:=WidthTitle;
             while ii<Mouse.X do
             begin
                inc(ii,GetWidthCol(Delta.X+i));
                inc(i);
             end;
             if i-1<0 then CurPos.X:=0 else CurPos.X:=i-1;
             if CurPos.X>Limit.X then
                if grOptions and grAutoSize <> 0 then inc(Limit.X)
                else exit;
             UpDate(ufLine);
          end
          else
          begin
{            if Event.What = evMouseAuto then Inc(Count);}
 {              if Count = MouseAutosToSkip then
               begin
                  Count := 0;}
                  if Mouse.Y < 1 then LineUp
                  else
                  if Mouse.Y >= Size.Y then LineDown
                  else
                  if (Mouse.X < WidthTitle) then LineLeft
                  else
                  if (Mouse.X>Size.X-1) then LineRight;
{               end;}
          end;
      until not MouseEvent(Event, evMouseMove + evMouseAuto);
      if Event.Double then EditData;
      ClearEvent(Event);
    end;
    evKeyDown:
    begin
      case Event.KeyCode of
        kbUp:LineUp;
        kbDown:LineDown;
        kbLeft:LineLeft;
        kbRight:LineRight;
        kbEnter:EditData;
        kbPgUp:PgUp;
        kbPgDn:PgDn;
        kbHome:Home;
        kbCtrlLeft:SetWidthCol(CurPos.X,GetWidthCol(CurPos.X)-1);
        kbCtrlRight:SetWidthCol(CurPos.X,GetWidthCol(CurPos.X)+1);
        kbCtrlPgDn:EndDoc;
        kbCtrlPgUp:Home;
        kbShiftIns:ClipCopy;
      else
        if Event.CharCode>#31 then
        begin
          PutEvent(Event);
          EditData;
        end
        else
          exit;
      end;
    end;
    evCommand:
    case Event.Command of
      cmGridHideSel:HideSelect;
      cmGridShowSel:ShowSelect;
      cmGridCopy:ClipCopy;
      cmToggleAutoCalc:ToggleAutoCalc;
    else
       exit;
    end;
    evBroadcast:
    case Event.Command of
      cmDestroed:DestroyLinks;
      cmScrollBarChanged:
           if (LookFlag<>-1) and ((Event.InfoPtr = HScrollBar) or
               (Event.InfoPtr = VScrollBar)) then
            begin
               CheckScrollBar(HScrollBar, CurPos.X);
               CheckScrollBar(VScrollBar, CurPos.Y);
               if not CursorVisible then
                  ScrollTo(CurPos.X-Delta.X,CurPos.Y-Delta.Y);
            end
            else
               Exit;
      cmFindTopGrid:
            begin
               ClearEvent(Event);
               exit;
            end;
      else
        Exit;
      end;
  else
    exit;
  end;
  FocusItem(CurPos.X, CurPos.Y);
  ClearEvent(Event);
end;

function TDrawGrid.GetText(Col,Rov:Word; MaxLen:byte; DisplayText:Boolean):string;
begin
  if Assigned(OnGetText) then
     GetText:=OnGetText(@Self, Col,Rov,MaxLen, DisplayText)
  else GetText:='';
end;

function TDrawGrid.GetValue(Col,Rov:Word; MaxLen:byte):string;
begin
  GetValue:=GetText(Col,Rov,MaxLen, false);
end;

procedure TDrawGrid.UpdateCommands;
begin
end;

procedure TDrawGrid.SetSelect(SBeg,SEnd:TPoint);
begin
  if (SBeg.X>SEnd.X) or (SBeg.Y>SEnd.Y) then
     Selecting:=false
  else
  begin
    Selecting:=true;
    SelectStart:=SBeg;
    SelectEnd:=SEnd;
  end;
  UpDate(ufLine);
end;

procedure TDrawGrid.Update(AMode:word);
begin
  UpdateFlags:=UpdateFlags or AMode;
  if LookFlag=0 then DoUpdate;
end;

procedure TDrawGrid.Look;
begin
  inc(LookFlag);
end;

procedure TDrawGrid.UnLook;
begin
  Dec(LookFlag);
  if LookFlag=0 then DoUpdate;
end;

function TDrawGrid.CursorVisible:boolean;
var
  i,ii:integer;
begin
  ii:=0;
  i:=Delta.X;
  while ii<Size.X-6 do
  begin
    inc(ii,GetWidthCol(i));
    inc(i)
  end;
  CursorVisible:=( CurPos.Y >= Delta.Y) and
                 ( CurPos.Y <= ( Delta.Y + Size.Y - 1)) and
                 ( CurPos.X >= Delta.X ) and
                 ( CurPos.X <= ( i - 1));
end;

function TDrawGrid.ContinueSelect:boolean;
begin
  ContinueSelect:=true;
  EndSelecting:=(ScrollMode=#25) or (ScrollMode=#26);
  if not Selecting then
  begin
    SetSelect(CurPos,CurPos);
    exit;
  end;
  if (CurPos.X = SelectEnd.X) and (CurPos.Y = SelectEnd.Y) then
     EndSelecting:=true
  else
     if (CurPos.X = SelectStart.X) and (CurPos.Y = SelectStart.Y) then
        EndSelecting:= false
     else
        SetSelect(CurPos,CurPos)
end;

procedure TDrawGrid.HideSelect;
begin
  Selecting:=false;
  Update(ufView);
end;

procedure TDrawGrid.ShowSelect;
begin
  Selecting:=true;
  Update(ufView);
end;

function TDrawGrid.SetValue(APos:TPoint;var AStr:String):boolean;
begin
  if Assigned(OnDrawGridSetValueEvent) then
     SetValue:=OnDrawGridSetValueEvent(@Self, APos, AStr)
  else SetValue:=false;
end;

procedure TDrawGrid.EditData;
var
  Pos:TPoint;
  R:TRect;
  P:Pointer;
  S:string;
  X,Y,i,Q:integer;
  IL:PInputLine;
  E:TEvent;
  ModalResult:word;
begin
  if (Limit.X=0) and (Limit.Y=0) then exit;
  if (grNotEdit and grOptions <> 0) or
  not Editing(CurPos.X,CurPos.Y) then
  begin
    FillChar(E,SizeOf(TEvent),0);
    PutEvent(E);
    exit;
  end;
  S:=GetValue(CurPos.X,CurPos.Y,255);
  X:=WidthTitle+Origin.X;
  for i:=Delta.X to CurPos.X-1 do X:=X+GetWidthCol(i);
  y:=CurPos.Y-Delta.Y+1+Origin.Y;
  R.Assign(X,Y,Size.X+1,Y+1);
  grOptions:= grOptions or grEdit;
  UpDate(ufLine);
  if Assigned(OnDrawGridEdit) then
     ModalResult:=OnDrawGridEdit(@Self, R, S)
  else
  begin
    IL:=New(PGridInputLine,Init(R, 255));
    IL^.SetValidator(Validator);
    Owner^.Insert(IL);
    IL^.SetData(S);
    repeat
      Q:=cmCancel;
      ModalResult:=Owner^.ExecView(IL);
      if ModalResult<>cmCancel then
      begin
         IL^.GetData(S);
         if not SetValue(CurPos,S) then
         begin
            P:=@S;
            Q:=ErrorMessage( mcDataError,@P, mfError+mfOkButton);
{            GridDialog( sdDataError, @P);}
         end
         else Modified:=true;
      end;
    until Q=cmCancel;
    Owner^.Delete(IL);
    IL^.Validator:=nil;
    IL^.Free;
  end;
  Select;
  grOptions:= grOptions and not grEdit;
  UpDate(ufLine);
  case ModalResult of
  cmOk:case byte(ScrollMode) of
         24:LineUp;
         25:LineDown;
         26:LineRight;
         27:LineLeft;
       end;
  cmYes:LineUp;
  cmNo:LineDown;
  end;
end;

function TDrawGrid.ItsNull(const X,Y:Word):boolean;
begin
  ItsNull:=false;
end;

procedure TDrawGrid.PutDate(const X,Y:word; var S:TStream);
begin
  abstract;
end;

procedure TDrawGrid.GetDate(const X,Y:word; var S:TStream; AStatus:Boolean);
begin
  abstract;
end;


procedure TDrawGrid.ClipCopy;
var
  P:TPoint;
  S:PStream;
  l,i,j,ii,jj, MaxX,MaxY:integer;
  k:Longint;
begin
  if not Selecting then exit;
  MaxX:=Limit.X; MaxY:=Limit.Y;
  S:=GetTempStream;
  k:=0;
  for j:=SelectStart.Y to SelectEnd.Y do
    for i:=SelectStart.X to SelectEnd.X do
        if not ItsNull(i,j) then
        begin
          ii:=i-SelectStart.X;
          jj:=j-SelectStart.Y;
          S^.Write(II,SizeOf(Integer));
          S^.Write(JJ,SizeOf(Integer));
          PutDate(i,j,S^);
          inc(K);
        end;
  S^.Seek(0);
  for l:=0 to k-1 do
  begin
    S^.Read(I,SizeOf(Integer));
    S^.Read(J,SizeOf(Integer));
    GetDate(CurPos.X+i,CurPos.Y+j,S^,
      (CurPos.X+I<Limit.X) and (CurPos.Y+J<Limit.Y));
    if grOptions and grAutoSize<>0 then
    begin
      MaxX:=Max(CurPos.X+I,MaxX);
      MaxY:=Max(CurPos.Y+J,MaxY);
    end;
  end;
  S^.Free;
  if grOptions and grAutoSize<>0 then SetLimit(MaxX+1,MaxY+1)
  else Update(ufView);
end;

procedure TDrawGrid.Store(var S:TStream);
begin
  inherited Store(S);
  PutPeerViewPtr(S, HScrollBar);
  PutPeerViewPtr(S, VScrollBar);
  PutPeerViewPtr(S, Indicator);
  S.Write(CurPos, SizeOf(TPoint)*5+SizeOf(Boolean));
  S.Write(ScrollMode, SizeOf(Char)+SizeOf(Byte));
  S.Write(WidthTitle,SizeOf(Integer));
  S.Put(Validator);
{$IFDEF VER70}
  StoreProcedure(S, @OnDrawGridEdit);
  StoreProcedure(S, @OnDrawGridDrawTitle);
  StoreProcedure(S, @OnWidthCollumnEvent);
  StoreProcedure(S, @OnGetText);
  StoreProcedure(S, @OnDrawGridSetValueEvent);
{$ENDIF}
end;

function TDrawGrid.Editing( X,Y:word):boolean;
begin
  if Assigned(OnEditing) then Editing:=OnEditing(@Self, X,Y)
  else Editing:=true;
end;

procedure TDrawGrid.FocusItem( X,Y: Integer);
begin
  Message(Owner, evBroadcast, cmGridFocused, @Self);
end;

function TDrawGrid.RowCount:integer;
begin
  RowCount:=Limit.Y+1;
end;

function TDrawGrid.ColCount:integer;
begin
  ColCount:=Limit.X+1;
end;

procedure TDrawGrid.SetState(AState: Word; Enable: Boolean);
begin
  inherited SetState(AState, Enable);
  case AState of
    sfActive:
      begin
        if HScrollBar <> nil then HScrollBar^.SetState(sfVisible, Enable);
        if VScrollBar <> nil then VScrollBar^.SetState(sfVisible, Enable);
        if Indicator <> nil then Indicator^.SetState(sfVisible, Enable);
{        UpdateCommands;}
      end;
{    sfExposed:
      if Enable then Unlook;}
  end;
  DrawTitle;
end;

function TDrawGrid.Align(const X,Y:word):TAlign;
begin
  if Assigned(OnDrawGridGetAlign) then Align:=OnDrawGridGetAlign(@Self, X,Y)
  else Align:=alLeft;
end;

procedure TDrawGrid.SetAlign(const X,Y:word;const aAlign:TAlign);
begin
  if Assigned(OnDrawGridSetAlign) then
     OnDrawGridSetAlign(@Self, X,Y,aAlign);
end;

  {TValue}
constructor TValue.Init(ARow:longint; AValue:string);
begin
  inherited Init;
  Row:=ARow;
  Value:=NewStr(AVAlue);
end;

destructor TValue.Done;
begin
  if Value<>nil then DisposeStr(Value);
  inherited Done;
end;

constructor TValue.Load(var S:TStream);
begin
  inherited Init;
  S.Read(Row, SizeOf(Longint));
  Value:=S.ReadStr;
  S.Read(Align, SizeOf(TAlign));
end;

procedure TValue.Store(var S:TStream);
begin
  S.Write(Row, SizeOf(Longint));
  S.WriteStr(Value);
  S.Write(Align, SizeOf(TAlign));
end;

function TValue.AsString:string;
begin
  if Value<>nil then AsString:=Value^
  else AsString:='';
end;

function TValue.AsFloat:real;
begin
  if Value<>nil then AsFloat:=StrToFloat(Value^)
  else AsFloat:=0;
end;

procedure TValue.SetAsString( AValue:String);
begin
  AssignStr(Value, AVAlue);
end;

procedure TValue.SetAsFloat( AVAlue:Real);
begin
  AssignStr(Value, FloatToStr(AVAlue));
end;

  {TCollumn}
constructor TCollumn.Init(ACol:longint; AValue:PValue);
begin
  inherited Init(10,5);
  if AValue<>nil then Insert(AValue);
  Column:=ACol;
  Width:=DefWidthCollumn;
end;

constructor TCollumn.Load(var S:TStream);
begin
  inherited Load(S);
  S.Read(Column, SizeOf(Longint));
  S.Read(Width, SizeOf(Integer));
end;

procedure TCollumn.Store(var S:TStream);
begin
  inherited Store(S);
  S.Write(Column, SizeOf(Longint));
  S.Write(Width, SizeOf(Integer));
end;

function TCollumn.AsString(ARow:longint):string;
var
  Index:integer;
begin
  if Search(Pointer(ARow),Index) then AsString:=PValue(At(Index))^.AsString
  else AsString:='';
end;

function TCollumn.AsFloat(ARow:longint):real;
var
  Index:integer;
begin
  if Search(Pointer(ARow),Index) then AsFloat:=PValue(At(Index))^.AsFloat
  else AsFloat:=0;
end;

procedure TCollumn.SetAsString(ARow:longint; AValue:String);
var
  Index:integer;
begin
  if Search(Pointer(ARow),Index) then
    if AVAlue<>'' then PValue(At(Index))^.SetAsString(AValue)
    else AtFree(Index)
  else
    if AValue<>'' then Insert(New(PValue, Init(ARow, AValue)));
end;

procedure TCollumn.SetAsFloat(ARow:longint; AVAlue:Real);
var
  Index:integer;
begin
  if Search(Pointer(ARow),Index) then PValue(At(Index))^.SetAsFloat(AValue)
  else Insert(New(PValue, Init(ARow, FloatToStr(AValue))));
end;

function TCollumn.KeyOf(Item: Pointer): Pointer;
begin
  KeyOf:=Pointer(PValue(Item)^.Row);
end;

function TCollumn.Compare(Key1, Key2: Pointer): Integer;
begin
  Compare:=Longint(Key1)-Longint(Key2);
end;

  {TCollumnCollection}
function TCollumnCollection.AsString(ACol,ARow:longint):string;
var
  Index:integer;
begin
  if Search(Pointer(ACol),Index) then
     AsString:=PCollumn(At(Index))^.AsString(ARow)
  else AsString:='';
end;

function TCollumnCollection.AsFloat(ACol,ARow:longint):real;
var
  Index:integer;
begin
  if Search(Pointer(ACol),Index) then
     AsFloat:=PCollumn(At(Index))^.AsFloat(ARow)
  else AsFloat:=0;
end;

procedure TCollumnCollection.SetAsString(ACol,ARow:longint; AValue:String);
var
  Index:integer;
begin
  if Search(Pointer(ACol),Index) then
  begin
     PCollumn(At(Index))^.SetAsString(ARow, AValue);
     if (AValue='') and (PCollumn(At(Index))^.Count=0) then
        AtFree(Index);
  end
  else
  if AValue<>'' then
     Insert(New(PCollumn, Init(ACol, New(PValue, Init(ARow, AValue)))));
end;

procedure TCollumnCollection.SetAsFloat(ACol,ARow:longint; AVAlue:Real);
var
  Index:integer;
begin
  if Search(Pointer(ACol),Index) then
     PCollumn(At(Index))^.SetAsFloat(ARow, AValue)
  else Insert(New(PCollumn, Init(ACol,
              New(PValue, Init(ARow, FloatToStr(AValue))))));
end;

function TCollumnCollection.Compare(Key1, Key2: Pointer): Integer;
begin
  Compare:=Longint(Key1)-Longint(Key2);
end;

function TCollumnCollection.KeyOf(Item: Pointer): Pointer;
begin
  KeyOf:=Pointer(PCollumn(Item)^.Column);
end;

function TCollumnCollection.Width(Collumn:Longint):integer;
var
  Index:integer;
begin
  if Search(Pointer(Collumn),Index) then
    Width:=Max(1,PCollumn(At(Index))^.Width)
  else Width:=DefWidthCollumn;
end;

procedure TCollumnCollection.SetWidth(Collumn:Longint; AWidth:integer);
var
  Index:integer;
  P:PCollumn;
begin
  if (AWidth<1) or (AWidth>255) then exit;
  if Search(Pointer(Collumn),Index) then P:=At(Index)
  else
  begin
    P:=New(PCollumn, Init(Collumn,  nil));
    Insert(P);
  end;
  P^.Width:=AWidth
end;

  {TStringGrid}
constructor TStringGrid.Init(var Bounds: TRect; AHScrollBar,
                           AVScrollBar:PScrollBar; AIndicator: PExtIndicator);
begin
  inherited Init( Bounds, AHScrollBar, AVScrollBar, AIndicator);
  Strings:=New(PCollumnCollection, Init(10,5));
  SetLimit(5,5);
  UpDate(ufView);
  ComponentType:=ctStringGrid;
end;

destructor TStringGrid.Done;
begin
  inherited Done;
  Dispose(Strings, Done);
end;

function TStringGrid.GetText(Col,Rov:Word; MaxLen:byte; DisplayText:Boolean):string;
begin
  GetText:=Copy(Strings^.AsString(Col,Rov),1,MaxLen);
end;

function TStringGrid.ItsNull(const X,Y:Word):boolean;
begin
  ItsNull:=Strings^.AsString(X,Y)='';
end;

procedure TStringGrid.PutDate(const X,Y:word; var S:TStream);
var _Align:TAlign;
begin
  _Align:=Align(X,Y);
  WriteString(S,Strings^.AsString(X,Y));
  S.Write(_Align, SizeOf(TAlign));
end;

procedure TStringGrid.GetDate(const X,Y:word; var S:TStream; AStatus:Boolean);
var _Align:TAlign;
begin
  Strings^.SetAsString(X,Y, ReadString(S));
  S.Read(_Align, SizeOf(TAlign));
  SetAlign(X,Y,_Align);
end;

function TStringGrid.SetValue(APos:TPoint;var AStr:String):boolean;
begin
  Strings^.SetAsString(APos.X,APos.Y, AStr);
end;

procedure TStringGrid.SaveFile(FileName:FNameStr);
var
   S:PDosStream;
begin
   S:=New(PDosStream, Init(FileName, stCreate));
   S^.Put(Strings);
   S^.Write(CurPos, SizeOf(TPoint));
   S^.Write(Delta, SizeOf(TPoint));
   S^.Write(Limit, SizeOf(TPoint));
   S^.Free;
end;

procedure TStringGrid.LoadFile(FileName:FNameStr);
var
   S:PDosStream;
begin
   Dispose(Strings, Done);
   S:=New(PDosStream, Init(FileName, stOpen));
   PObject(Strings):=S^.Get;
   S^.Read(CurPos, SizeOf(TPoint));
   S^.Read(Delta, SizeOf(TPoint));
   S^.Read(Limit, SizeOf(TPoint));
   S^.Free;
   DrawView;
end;

procedure TStringGrid.LoadAs;
var S:String;
begin
  S:='';
{  if GridDialog(sdLoadAs, @S)<>cmCancel then LoadFile(S);}
end;

procedure TStringGrid.SaveAs;
var S:String;
begin
  S:='';
{  if GridDialog(sdSaveAs, @S)<>cmCancel then SaveFile(S);}
end;

procedure TStringGrid.HandleEvent(var Event:TEvent);
begin
  inherited HandleEvent(Event);
  case Event.What of
       evCommand:
       case Event.Command of
            cmSGLoadAs:LoadAs;
            cmSGSaveAs:SaveAs;
            cmSGAlignLeft  :SetAlign(CurPos.X,CurPos.Y, alLeft);
            cmSGAlignCenter:SetAlign(CurPos.X,CurPos.Y, alCenter);
            cmSGAlignRight :SetAlign(CurPos.X,CurPos.Y, alRight);
       else
            exit;
       end;
       evKeyDown:
       if Hi(Event.KeyCode)<>0 then
       case GetCtrlChar(Event.KeyCode) of
         'L':SetAlign(CurPos.X,CurPos.Y, alLeft);
         'C':SetAlign(CurPos.X,CurPos.Y, alCenter);
         'R':SetAlign(CurPos.X,CurPos.Y, alRight);
       else
         exit;
       end;
  else
       exit;
  end;
  ClearEvent(Event);
end;

function TStringGrid.GetWidthCol( ACol:word):byte;
begin
  if Strings<>nil then GetWidthCol:=Strings^.Width(ACol)
  else GetWidthCol:=inherited GetWidthCol( ACol);
end;

procedure TStringGrid.SetWidthCol( ACol:word; AWidth:integer);
begin
  if Strings<>nil then Strings^.SetWidth(ACol, AWidth)
  else inherited SetWidthCol( ACol, AWidth);
  Update(ufView);
end;

constructor TStringGrid.Load(var S:TStream);
begin
  inherited Load(S);
  PObject(Strings):=S.Get;
end;

procedure TStringGrid.Store(var S:TStream);
begin
  inherited Store(S);
  S.Put(Strings);
end;

function TStringGrid.Align(const X,Y:word):TAlign;
var
  Index:integer;
  P:PCollumn;
begin
  Align:=alLeft;
  if Strings<>nil then
    with Strings^ do
    if Search(Pointer(X),Index) then
    begin
      P:=At(Index);
      if P^.Search(Pointer(Y),Index) then Align:=PValue(P^.At(Index))^.Align;
    end
end;

procedure TStringGrid.SetAlign(const X,Y:word;const aAlign:TAlign);
var
  Index:integer;
  P:PCollumn;
  Value:PValue;
begin
  if Strings<>nil then
  with Strings^ do
  begin
     if Search(Pointer(X),Index) then
     begin
       P:=At(Index);
       if P^.Search(Pointer(Y),Index) then Value:=PValue(P^.At(Index))
       else
       begin
         Value:=New(PValue, Init(Y, ''));
         P^.Insert(Value);
       end;
     end
     else
     begin
       Value:=New(PValue, Init(Y, ''));
       P:=New(PCollumn, Init(X,  Value));
       Insert(P);
     end;
     Value^.Align:=aAlign;
     Update(ufOneLine);
  end;
end;

procedure RegisterGrids;
begin
  RegisterType(RDrawGrid);
  RegisterType(RStringGrid);
  RegisterType(RValue);
  RegisterType(RCollumn);
  RegisterType(RCollumnCollection);
end;

end.
