{************************************************}
{                                                }
{   Turbo Vision Unit                            }
{                                                }
{   Turbo Pascal 7                               }
{   FreePacal                                    }
{   Delphi 2 - 5                                 }
{   Virtual Pascal 2.1                           }
{                                                }
{   Copyright (c) 1995-2000 by Alexs             }
{                                                }
{************************************************}


unit Register;

interface

{Standart commands}
const {Views}
  cmValid   = 0; { Standard command codes }
  cmQuit    = 1;
  cmError   = 2;
  cmMenu    = 3;
  cmClose   = 4;
  cmZoom    = 5;
  cmResize  = 6;
  cmNext    = 7;
  cmPrev    = 8;
  cmHelp    = 9;
  cmOK      = 10; { TDialog standard commands }
  cmCancel  = 11;
  cmYes     = 12;
  cmNo      = 13;
  cmDefault = 14;
  cmCut     = 20; { Application command codes }
  cmCopy    = 21;
  cmPaste   = 22;
  cmUndo    = 23;
  cmClear   = 24;
  cmTile    = 25;
  cmCascade = 26;
  cmRedo               = cmCascade             + 1;
  cmShowClip           = cmRedo                + 1;
const {App}
  cmNew               = 30; {App}{ Standard application commands }
  cmOpen              = 31; {App}
  cmSave              = 32; {App}
  cmSaveAs            = 33; {App}
  cmSaveAll           = 34; {App}
  cmChangeDir         = 35; {App}
  cmDosShell          = 36; {App}
  cmCloseAll          = 37; {App}

  cmReceivedFocus     = 50; { Standard messages }
  cmReleasedFocus     = 51;
  cmCommandSetChanged = 52;
  cmScrollBarChanged  = 53; { TScrollBar messages }
  cmScrollBarClicked  = 54;
  cmSelectWindowNum   = 55; { TWindow select messages }
  cmListItemSelected  = 56; { TListViewer messages }
  cmDestroed          = 57; { destroed object standart message}
  cmRecordHistory     = 60; {Dialogs} { Dialog broadcast commands }
  cmGrabDefault       = 61; {Dialogs} { TButton messages }
  cmReleaseDefault    = 62; {Dialogs} { TButton messages }
  cmClusterPress      = 65; {Dialogs} { Dialog broadcast commands }
  cmColorForegroundChanged = 71; {ColorSel}
  cmColorBackgroundChanged = 72; {ColorSel}
  cmColorSet               = 73; {ColorSel}
  cmNewColorItem           = 74; {ColorSel}
  cmNewColorIndex          = 75; {ColorSel}
  cmSaveColorIndex         = 76; {ColorSel}

const {WindList}
  cmDelWindow      = 90;
  cmWindowList     = 11000;
  {It's a standart apps commands}
  cmCalen              = cmWindowList          + 1;
  cmCalc               = cmCalen               + 1;
  cmReindex            = cmCalc                + 1;
  cmAbout              = cmReindex             + 1;
  cmAppOptions         = cmAbout               + 1;
  cmIdle               = cmAppOptions          + 1;

const {Editors}
  cmFind               = 82;
  cmReplace            = cmFind                + 1;
  cmSearchAgain        = cmReplace             + 1;
  cmGotoLine           = cmSearchAgain         + 1;
  cmPrintFile          = cmGotoLine            + 1;

  cmCharLeft             = 500;
  cmCharRight            = cmCharLeft                + 1;
  cmWordLeft             = cmCharRight               + 1;
  cmWordRight            = cmWordLeft                + 1;
  cmLineStart            = cmWordRight               + 1;
  cmLineEnd              = cmLineStart               + 1;
  cmLineUp               = cmLineEnd                 + 1;
  cmLineDown             = cmLineUp                  + 1;
  cmPageUp               = cmLineDown                + 1;
  cmPageDown             = cmPageUp                  + 1;
  cmTextStart            = cmPageDown                + 1;
  cmTextEnd              = cmTextStart               + 1;
  cmNewLine              = cmTextEnd                 + 1;
  cmBackSpace            = cmNewLine                 + 1;
  cmDelChar              = cmBackSpace               + 1;
  cmDelWord              = cmDelChar                 + 1;
  cmDelStart             = cmDelWord                 + 1;
  cmDelEnd               = cmDelStart                + 1;
  cmDelLine              = cmDelEnd                  + 1;
  cmInsMode              = cmDelLine                 + 1;
  cmStartSelect          = cmInsMode                 + 1;
  cmHideSelect           = cmStartSelect             + 1;
  cmEndSelect            = cmHideSelect              + 1;
  cmIndentMode           = cmEndSelect               + 1;
  cmUpdateTitle          = cmIndentMode              + 1;
  cmReformPara           = cmUpdateTitle             + 1;
  cmTabKey               = cmReformPara              + 1;
  cmInsertLine           = cmTabKey                  + 1;
  cmScrollUp             = cmInsertLine              + 1;
  cmScrollDown           = cmScrollUp                + 1;
  cmHomePage             = cmScrollDown              + 1;
  cmEndPage              = cmHomePage                + 1;
  cmJumpMark0            = cmEndPage                 + 1;
  cmJumpMark1            = cmJumpMark0               + 1;
  cmJumpMark2            = cmJumpMark1               + 1;
  cmJumpMark3            = cmJumpMark2               + 1;
  cmJumpMark4            = cmJumpMark3               + 1;
  cmJumpMark5            = cmJumpMark4               + 1;
  cmJumpMark6            = cmJumpMark5               + 1;
  cmJumpMark7            = cmJumpMark6               + 1;
  cmJumpMark8            = cmJumpMark7               + 1;
  cmJumpMark9            = cmJumpMark8               + 1;
  cmReformDoc            = cmJumpMark9               + 1;
  cmSetMark0             = cmReformDoc               + 1;
  cmSetMark1             = cmSetMark0                + 1;
  cmSetMark2             = cmSetMark1                + 1;
  cmSetMark3             = cmSetMark2                + 1;
  cmSetMark4             = cmSetMark3                + 1;
  cmSetMark5             = cmSetMark4                + 1;
  cmSetMark6             = cmSetMark5                + 1;
  cmSetMark7             = cmSetMark6                + 1;
  cmSetMark8             = cmSetMark7                + 1;
  cmSetMark9             = cmSetMark8                + 1;
  cmSelectWord           = cmSetMark9                + 1;
  cmSaveExit             = cmSelectWord              + 1;
  cmCenterText           = cmSaveExit                + 1;
  cmSetTabs              = cmCenterText              + 1;
  cmRightMargin          = cmSetTabs                 + 1;
  cmWordwrap             = cmRightMargin             + 1;
  cmBludgeonStats        = cmWordwrap                + 1;
  cmPrinterSetup         = cmBludgeonStats           + 1;
  cmClipboard            = cmPrinterSetup            + 1;
  cmSpellCheck           = cmClipboard               + 1;
  cmCopyBlock            = cmSpellCheck              + 1;
  cmMoveBlock            = cmCopyBlock               + 1;
  cmDelSelect            = cmMoveBlock               + 1;
  cmIdentBlock           = cmDelSelect               + 1;
  cmUnidentBlock         = cmIdentBlock              + 1;
  cmFileHistory          = cmUnidentBlock            + 1;
  cmFindByName           = cmFileHistory             + 1;
  cmAddToCollect         = cmFindByName              + 1;
  cmFindTopEditor        = cmAddToCollect            + 1;
const {DataCtrl}
  cmPrevRec              = cmFindTopEditor           + 1;
  cmNextRec              = cmPrevRec                 + 1;
  cmFirstRec             = cmNextRec                 + 1;
  cmLastRec              = cmFirstRec                + 1;
  cmMoveBy               = cmLastRec                 + 1;
  cmDeleteRec            = cmMoveBy                  + 1;
  cmRecalRec             = cmDeleteRec               + 1;
  cmEditRec              = cmRecalRec                + 1;
  cmAppendRec            = cmEditRec                 + 1;
  cmPostRec              = cmAppendRec               + 1;
  cmCancelRec            = cmPostRec                 + 1;
  cmUpDataDS             = cmCancelRec               + 1;
  cmNewTable             = cmUpDataDS                + 1;
  cmAfterLoadDS          = cmNewTable                + 1;
  cmFindDataSourse       = cmAfterLoadDS             + 1;
  cmAfterPost            = cmFindDataSourse          + 1;
  cmBeforePost           = cmAfterPost               + 1;
  cmBeforeDelete         = cmBeforePost              + 1;
  cmAfterDelete          = cmBeforeDelete            + 1;
const {Reports}
  cmPrintReport          = cmAfterDelete             + 1;
  cmPreviewReport        = cmPrintReport             + 1;
  cmSaveReport           = cmPreviewReport           + 1;
  cmBeforePrint          = cmSaveReport              + 1;
  cmAfterPrint           = cmBeforePrint             + 1;
  cmAfterLoadReport      = cmAfterPrint              + 1;
  cmFistPagePreView      = cmAfterLoadReport         + 1;
  cmPrevPagePreView      = cmFistPagePreView         + 1;
  cmNextPagePreView      = cmPrevPagePreView         + 1;
  cmLastPagePreView      = cmNextPagePreView         + 1;
  cmFindReport           = cmLastPagePreView         + 1;
const {DBGrids}
  cmDBGridSelect         = cmFindReport              + 1;
  cmDataScrollerClicked  = cmDBGridSelect            + 1;
  cmDataScrollerChanged  = cmDataScrollerClicked     + 1;
  cmDBGridFirst          = cmDataScrollerChanged     + 1;
  cmDBGridLast           = cmDBGridFirst             + 1;
  cmDBGridNext           = cmDBGridLast              + 1;
  cmDBGridPrev           = cmDBGridNext              + 1;
const {Grids}
  cmGridHideSel          = cmDBGridPrev              + 1;
  cmGridShowSel          = cmGridHideSel             + 1;
  cmGridCopy             = cmGridShowSel             + 1;
  cmToggleAutoCalc       = cmGridCopy                + 1;
  cmFindTopGrid          = cmToggleAutoCalc          + 1;
  cmGridFocused          = cmFindTopGrid             + 1;
  cmSGLoadAs             = cmGridFocused             + 1;
  cmSGSaveAs             = cmSGLoadAs                + 1;
  cmSGAlignLeft          = cmSGSaveAs                + 1;
  cmSGAlignCenter        = cmSGAlignLeft             + 1;
  cmSGAlignRight         = cmSGAlignCenter           + 1;
const {Cursors}
  cmCurentChang          = cmSGAlignRight            + 1;
  cmCurSelect            = cmCurentChang             + 1;
  cmLocalMenu            = cmCurSelect               + 1;
const {AddCntrl}
  cmColorTextChanged     = cmLocalMenu               + 1;
  cmViewChanged          = cmColorTextChanged        + 1;
  cmFindOutput           = cmViewChanged             + 1;
  cmDateSelected         = cmFindOutput              + 1;
const {Gauges}
  cmUpdateGauge          = cmDateSelected            + 1;
  cmResetGauge           = cmUpdateGauge             + 1;
  cmAddGauge             = cmResetGauge              + 1;
const {Outline}
  cmOutlineItemSelected  = cmAddGauge                + 1;
const {El_Lists}
  cmNewElementItem       = cmOutlineItemSelected     + 1;
  cmNewElementIndex      = cmNewElementItem          + 1;
const {Prn_Mng}
  cmDelItem              = cmNewElementIndex         + 1;
  cmContinuePrint        = cmDelItem                 + 1;
  cmStopPrint            = cmContinuePrint           + 1;
const {StdDlg}
  cmFileOpen             = cmStopPrint               + 1; { Returned from TFileDialog when Open pressed }
  cmFileReplace          = cmFileOpen                + 1; { Returned from TFileDialog when Replace pressed }
  cmFileClear            = cmFileReplace             + 1; { Returned from TFileDialog when Clear pressed }
  cmFileInit             = cmFileClear               + 1; { Used by TFileDialog internally }
  cmChDir                = cmFileInit                + 1; { Used by TChDirDialog internally }
  cmRevert               = cmChDir                   + 1; { Used by TChDirDialog internally }
  cmFileFocused          = cmRevert                  + 1; { A new file was focused in the TFileList }
  cmFileDoubleClicked    = cmFileFocused             + 1; { A file was selected in the TFileList }

(*Editors*)
  cmFileNameChanged      = 51234;
  cmASCIIChar            = 51235;
  cmClearLineHighlights  = 51236;
  cmSaveCancelled        = 51237;
  cmBreakLine            = 51238;
  cmSelectStart             = 51239;
  cmSelectEnd               = 51240;
  cmLastCursorPos        = 51241;
  cmIndentBlock          = 51242;
  cmUnIndentBlock        = 51243;
  cmSelectLine           = 51244;
  cmWriteBlock           = 51245;
  cmReadBlock            = 51246;
  cmPrintBlock           = 51247;


type
    TComponentType = byte;
    TTypeSet = set of TComponentType;

{Copmponet type codes}
const {Views}
  ctUknow                 = 0; {Views}
  ctView                  = 1; {Views}
  ctFrame                 = 2; {Views}
  ctScrollBar             = 3; {Views}
  ctScroller              = 4; {Views}
  ctListViewer            = 5; {Views}
  ctGroup                 = 6; {Views}
  ctWindow                = 7; {Views}
  ctDialog                = 8;  {Dialogs}
  ctInputLine             = 9;  {Dialogs}
  ctButton                = 10; {Dialogs}
  ctCluster               = 11; {Dialogs}
  ctRadioButtons          = 12; {Dialogs}
  ctCheckBoxes            = 13; {Dialogs}
  ctMultiCheckBoxes       = 14; {Dialogs}
  ctListBox               = 15; {Dialogs}
  ctStaticText            = 16; {Dialogs}
  ctParamText             = 17; {Dialogs}
  ctLabel                 = 18; {Dialogs}
  ctHistoryViewer         = 19; {Dialogs}
  ctHistoryWindow         = 20; {Dialogs}
  ctHistory               = 21; {Dialogs}
  ctIndicator             = 22; {Editors}
  ctEditor                = 23; {Editors}
  ctMemo                  = 24; {Editors}
  ctHeapView              = 25; {Gadgets}
  ctFileEditor            = 26; {Editors}
  ctEditWindow            = 27; {Editors}
  ctPercentGauge          = 28; {Gauges}
  ctBarGauge              = 29; {Gauges}
  ctOutlineViewer         = 30; {Outline}
  ctOutline               = 31; {Outline}
  ctGridInputLine         = 32; {Grids}
  ctDrawGrid              = 33; {Grids}
  ctStringGrid            = 34; {Grids}
  ctFileInputLine         = 35; {StdDlg}
  ctSortedListBox         = 36; {StdDlg}
  ctFileList              = 37; {StdDlg}
  ctFileInfoPane          = 38; {StdDlg}
  ctFileDialog            = 39; {StdDlg}
  ctDirListBox            = 40; {StdDlg}
  ctChDirDialog           = 41; {StdDlg}
  ctMultiSelBox           = 42; {MultiSel}
  ctMenuView              = 43; {Menus}
  ctMenuBar               = 44; {Menus}
  ctMenuBox               = 45; {Menus}
  ctMenuPopup             = 46; {Menus}
  ctStatusLine            = 47; {Menus}
  ctAboutPanel            = 48; {AboutPn}
  ctDataSourse            = 49; {DataCtrl}
  ctDBSourse              = 50; {DataCtrl}
  ctElementGroupList      = 51; {El_Lists}
  ctElementItemList       = 52; {El_Lists}
  ctInputLineUC           = 53; {AddCntrl}
  ctInputLinePS           = 54; {AddCntrl}
  ctInputLineLC           = 55; {AddCntrl}
  ctFilterInput           = 56; {AddCntrl}
  ctColorText             = 57; {AddCntrl}
  ctRangeILine            = 58; {AddCntrl}
  ctInputSegOfs           = 59; {AddCntrl}
  ctLockUpBox             = 60; {AddCntrl}
  ctLockUpInputLine       = 61; {AddCntrl}
  ctOkListBox             = 62; {AddCntrl}
  ctOutputViewer          = 63; {AddCntrl}
  ctCalenPanel            = 64; {AddCntrl}
  ctDateEdit              = 65; {AddCntrl}
  ctDBLookupCombo         = 66; {DBCtrls}
  ctDBText                = 67; {DBCtrls}
  ctDBEdit                = 68; {DBCtrls}
  ctDBGrid                = 69; {DBGrids}
  ctASCIITable            = 70; {ASCIITab}
  ctASCIIReport           = 71; {ASCIITab}
  ctASCIIChart            = 72; {ASCIITab}
  ctClockView             = 73; {Gadgets}
  ctCursor                = 74; {Cursors}
  ctReportBandBackground  = 75; {Reporst}
  ctReportBand            = 76; {Reporst}
  ctReport                = 77; {Reporst}
  ctReportLabel           = 78; {Reporst}
  ctDBLockUpText          = 79; {DBCtrls}
  ctDBCluster             = 80; {DBCtrls}
  ctDBRadioButtons        = 81; {DBCtrls}
  ctDBCheckBox            = 82; {DBCtrls}
  ctTabbedNotebook        = 83; {TabNotbk}
  ctDBLookupEdit          = 84; {DBCtrls}
  ctDataScroller          = 85; {DBGrids}
  ctQuery                 = 86; {Querys}
  ctDBNavigatorBtn        = 87; {DBCtrls}
  ctColorSelector         = 88; {ColorSel}
  ctMonoSelector          = 89; {ColorSel}
  ctColorDisplay          = 90; {ColorSel}
  ctReportMemo            = 91; {Reporst}
  ctDBMemo                = 92; {DBCtrls}
  ctDBDateEdit            = 93; {DBCtrls}
  ctReportShape           = 94; {Reporst}
  ctVirtualDataSet        = 95; {Reporst}
  ctUserDataSet           = 96; {Reporst}
  ctMenuButton            = 97; {Menus}
  ctGroupBand             = 98; {Reports}
const
  CountComponents         = 98;

{Component registartion codes}
const
  rcView                  = 1;     {Views}
  rcFrame                 = 2;     {Views}
  rcScrollBar             = 3;     {Views}
  rcScroller              = 4;     {Views}
  rcListViewer            = 5;     {Views}
  rcGroup                 = 6;     {Views}
  rcWindow                = 7;     {Views}
  rcDialog                = 10;    {Dialogs}
  rcInputLine             = 11;    {Dialogs}
  rcButton                = 12;    {Dialogs}
  rcCluster               = 13;    {Dialogs}
  rcRadioButtons          = 14;    {Dialogs}
  rcCheckBoxes            = 15;    {Dialogs}
  rcListBox               = 16;    {Dialogs}
  rcStaticText            = 17;    {Dialogs}
  rcLabel                 = 18;    {Dialogs}
  rcHistory               = 19;    {Dialogs}
  rcParamText             = 20;    {Dialogs}
  rcColorSelector         = 21;    {ColorSel}
  rcMonoSelector          = 22;    {ColorSel}
  rcColorDisplay          = 23;    {ColorSel}
  rcColorGroupList        = 24;    {ColorSel}
  rcColorItemList         = 25;    {ColorSel}
  rcColorDialog           = 26;    {ColorSel}
  rcMultiCheckBoxes       = 27;    {Dialogs}
  rcBackground            = 30;    {App}
  rcDesktop               = 31;    {App}
  rcMenuBar               = 40;    {Menus}
  rcMenuBox               = 41;    {Menus}
  rcStatusLine            = 42;    {Menus}
  rcMenuPopup             = 43;    {Menus}
  rcMenuButton            = 44;    {Menus}
  rcFileInputLine         = 60;    {StdDlg}
  rcFileCollection        = 61;    {StdDlg}
  rcFileList              = 62;    {StdDlg}
  rcFileInfoPane          = 63;    {StdDlg}
  rcFileDialog            = 64;    {StdDlg}
  rcDirCollection         = 65;    {StdDlg}
  rcDirListBox            = 66;    {StdDlg}
  rcChDirDialog           = 67;    {StdDlg}
  rcSortedListBox         = 68;    {StdDlg}
  rcPXPictureValidator    = 80;    {Validate}
  rcFilterValidator       = 81;    {Validate}
  rcRangeValidator        = 82;    {Validate}
  rcStringLookupValidator = 83;    {Validate}
  rcOutline               = 91;    {Outline}
  rcPercentGauge          = 1000;  {Gauges}
  rcBarGauge              = 1001;  {Gauges}
  rcMultiSelBox           = 2002;  {MultiSel}
  rcElementGroupList      = 2003;  {El_Lists}
  rcElementItemList       = 2004;  {El_Lists}
  rcInputLineUC           = 2005;  {AddCntrl}
  rcInputLineLC           = 2006;  {AddCntrl}
  rcInputLinePS           = 2007;  {AddCntrl}
  rcFilterInput           = 2008;  {AddCntrl}
  rcColorText             = 2009;  {AddCntrl}
  rcDataScroller          = 2011;  {DataCtrl}
  rcRangeILine            = 2012;  {AddCntrl}
  rcAboutPanel            = 2013;  {AboutPn}
  rcInputSegOfs           = 2014;  {AddCntrl}
  rcLockUpBox             = 2022;  {AddCntrl}
  rcLockUpInputLine       = 2024;  {AddCntrl}
  rcOkListBox             = 2025;  {AddCntrl}
  rcClockView             = 2026;  {Gadgets}
  rcValue                 = 2027;  {Grids}
  rcCollumn               = 2028;  {Grids}
  rcCollumnCollection     = 2029;  {Grids}
  rcDrawGrid              = 2030;  {Grids}
  rcStringGrid            = 2031;  {Grids}
  rcOutputViewer          = 2032;  {AddCntrl}
  rcCalenPanel            = 2033;  {AddCntrl}
  rcDateEdit              = 2034;  {AddCntrl}
  rcASCIITable            = 2035;  {ASCIITab}
  rcASCIIReport           = 2036;  {ASCIITab}
  rcASCIIChart            = 2037;  {ASCIITab}
  rcTabbedNotebook        = 2038;  {TabNotbk}
  rcRDateValidator        = 2039;  {AddCntrl}
  rcExtIndicator          = 2050;  {Ext_Edit}
  rcExtEditor             = 2051;  {Ext_Edit}
  rcExtFileEditor         = 2052;  {Ext_Edit}
  rcExtEditWindow         = 2053;  {Ext_Edit}
  rcLargeScrollBar        = 2054;  {AddCntrl}
  rcForm                  = 2070;  {Forms}
  rcDataSourse            = 5000;  {DataCtrl}
  rcDBSourse              = 5001;  {DataCtrl}
  rcDBLookupCombo         = 5002;  {DBCtrls}
  rcDBText                = 5003;  {DBCtrls}
  rcDBEdit                = 5004;  {DBCtrls}
  rcDBGrid                = 5005;  {DBGrids}
  rcDBGridField           = 5006;  {DBGrids}
  rcReportBand            = 5008;  {Reports}
  rcReport                = 5009;  {Reports}
  rcReportLabel           = 5010;  {Reports}
  rcDBLockUpText          = 5021;  {DBCtrls}
  rcDBRadioButtons        = 5022;  {DBCtrls}
  rcDBCheckBox            = 5023;  {DBCtrls}
  rcDBListBox             = 5024;  {DBCtrls}
  rcDBLookupEdit          = 5025;  {DBCtrls}
  rcQuery                 = 5026;  {Querys}
  rcParam                 = 5027;  {Querys}
  rcParamList             = 5028;  {Querys}
  rcDBNavigatorBtn        = 5029;  {DBCtrls}
  rcReportMemo            = 5030;  {Reports}
  rcDBMemo                = 5031;  {DBCtrls}
  rcFieldWraper           = 5032;  {DataCtrl}
  rcDBDateEdit            = 5033;  {DBCtrls}
  rcReportShape           = 5034;  {Reports}
  rcVirtualDataSet        = 5035;  {Reports}
  rcUserDataSet           = 5036;  {Reports}
  rcGroupBand             = 5037;  {Reports}
  rcPuzzleView            = 10010; {Puzzle}
  rcPuzzleWindow          = 10011; {Puzzle}
  rcCalendarView          = 10020; {Calendar}
  rcCalendarWindow        = 10021; {Calendar}
  rcCalcDisplay           = 10040; {Calc}
  rcCalculator            = 10041; {Calc}

const

{ Message box classes }

  mfWarning      = $0000;       { Display a Warning box }
  mfError        = $0001;       { Dispaly a Error box }
  mfInformation  = $0002;       { Display an Information Box }
  mfConfirmation = $0003;       { Display a Confirmation Box }
  mfInsertInApp  = $0080;       { Insert message box into application }
                                { instead of the Desktop }

{ Message box button flags }

  mfYesButton    = $0100;       { Put a Yes button into the dialog }
  mfNoButton     = $0200;       { Put a No button into the dialog }
  mfOKButton     = $0400;       { Put an OK button into the dialog }
  mfCancelButton = $0800;       { Put a Cancel button into the dialog }

  mfYesNoCancel  = mfYesButton + mfNoButton + mfCancelButton;
  mfYesNo        = mfYesButton + mfNoButton;
                                { Standard Yes, No, Cancel dialog }
  mfOKCancel     = mfOKButton + mfCancelButton;
                                { Standard OK, Cancel dialog }



const
  AllType = [ ctUknow..High(TComponentType)];

  SystemTypeSet = [ctWindow, ctFrame, ctDialog, ctCursor,
                              ctReportBandBackground];
  DSSet = [ctDBSourse, ctQuery, ctVirtualDataSet, ctUserDataSet];

  LabelSet  = [ctInputLine, ctListBox, ctRadioButtons, ctCheckBoxes,
                         ctMultiCheckBoxes, ctMemo, ctMultiSelBox, ctOutline,
                         ctElementGroupList, ctElementItemList, ctInputLineUC,
                         ctInputLineLC, ctInputLinePS, ctFilterInput,
                         ctOkListBox, ctDrawGrid, ctStringGrid, ctDateEdit,
                         ctLockUpInputLine, ctRangeILine, ctSortedListBox,
                         ctDBGrid, ctDBLookupCombo, ctDBEdit, ctDBMemo,
                         ctDBDateEdit, ctDBLookupEdit,
                         ctColorSelector, ctMonoSelector ];
  NotLinkSet = [ctFrame, ctCursor, ctReportShape,
      ctStaticText, ctScrollBar, ctInputLine,
      ctButton, ctIndicator, ctPercentGauge, ctBarGauge, ctParamText,
      ctInputLineUC, ctInputLineLC, ctInputLinePS, ctFilterInput,
      ctColorText, ctLockUpInputLine, ctRangeILine, ctDateEdit,
      ctAboutPanel,  ctClockView, ctASCIITable, ctASCIIReport,
      ctQuery, ctCluster, ctRadioButtons, ctCheckBoxes, ctMultiCheckBoxes,
      ctColorSelector, ctMonoSelector, ctColorDisplay];

  GroupControl     = [ctReportBand, ctGroupBand];

  BackGComp        = [ctReportBandBackground, ctFrame];
  ComponentToGroup = [ctStaticText, ctReportLabel, ctDBText,
                      ctDBLockUpText, ctDBRadioButtons,
                      ctDBCheckBox, ctReportMemo, ctReportShape];
  NotVisualConteyner = [ctDBSourse, ctQuery, ctDataSourse];

implementation
end.
