unit IBTypes;
interface
uses Windows, SysUtils;
//  Isc_Status           = Int32;
(*  PCTimeStructure      = ^TCTimeStructure;
  TCTimeStructure = record
    tm_sec : integer;   // Seconds
    tm_min : integer;   // Minutes
    tm_hour : integer;  // Hour (0--23)
    tm_mday : integer;  // Day of month (1--31)
    tm_mon : integer;   // Month (0--11)
    tm_year : integer;  // Year (calendar year minus 1900)
    tm_wday : integer;  // Weekday (0--6) Sunday = 0)
    tm_yday : integer;  // Day of year (0--365)
    tm_isdst : integer; // 0 if daylight savings time is not in effect)
  end;
  PIsc_Long            = ^Isc_Long;
  Isc_Long             = Int32;    // 32 bit signed
  UIsc_Long            = ULong;   // 32 bit unsigned*)
type
  Int                  = LongInt; // 32 bit signed
  UInt                 = DWord;   // 32 bit unsigned
  Long                 = LongInt; // 32 bit signed
  ULong                = DWord;   // 32 bit unsigned
  Short                = SmallInt;// 16 bit signed
  UShort               = Word;    // 16 bit unsigned
  Float                = Single;  // 32 bit
  UChar                = Byte;    // 8 bit unsigned
  ISC_LONG             = Long;    // 32 bit signed
type  
  UISC_LONG            = ULong;   // 32 bit unsigned
  ISC_STATUS           = Long;    // 32 bit signed
  UISC_STATUS          = ULong;   // 32 bit unsigned
  Void                 = Pointer;
  // Delphi "Pointer types"
  PPChar               = ^PChar;
  PSmallInt            = ^SmallInt;
  PInt                 = ^Int;
  PInteger             = ^Integer;
  PShort               = ^Short;
  PUShort              = ^UShort;
  PLong                = ^Long;
  PULong               = ^ULong;
  PFloat               = ^Float;
  PUChar               = ^UChar;
  PVoid                = ^Pointer;
  PDouble              = ^Double;
  PISC_LONG            = ^ISC_LONG;
  PUISC_LONG           = ^UISC_LONG;
  PStatusVector = ^TStatusVector;
  PPIsc_Status         = ^PIsc_Status;
  PUISC_STATUS         = ^UISC_STATUS;
  PIsc_Status          = ^Isc_Status;
  TStatusVector = array [0..19] of Isc_Status;

  { C Date/Time Structure }
  TCTimeStructure = record
    tm_sec : integer;   // Seconds
    tm_min : integer;   // Minutes
    tm_hour : integer;  // Hour (0--23)
    tm_mday : integer;  // Day of month (1--31)
    tm_mon : integer;   // Month (0--11)
    tm_year : integer;  // Year (calendar year minus 1900)
    tm_wday : integer;  // Weekday (0--6) Sunday = 0)
    tm_yday : integer;  // Day of year (0--365)
    tm_isdst : integer; // 0 if daylight savings time is not in effect)
  end;
  PCTimeStructure = ^TCTimeStructure;
  TM              = TCTimeStructure;
  PTM             = ^TM;

type
  // Exception Classes
  EIBError = class(Exception);
  EIBDLLLoadError = class(EIBError);

implementation
end.