{*******************************************************}
{                                                       }
{       Turbo Pascal Version 7.0                        }
{       FreePacal                                       }
{       Delphi 4                                        }
{       Demo large text editor                          }
{     Text size > 10 Mb in real mode!                   }
{                                                       }
{       Copyright (c) 1995-99 by Alexs                  }
{                                                       }
{*******************************************************}

uses Objects, App, VMM, Ext_Edit, Views, Dialogs, GadGets, ListWind,
     Drivers, Register, StdDlg, Menus, MsgBox, AddCntrl, Clases, Calc,
     ResTools, ShardEdt, Ext_Dos, Std_Str;

const
  HeapSize = 32 * (1024 div 16);

const
  cmCalculator          = 101;
  cmShowClip            = cmCalculator          + 1;
  cmOptions             = cmShowClip            + 1;

type
  TDemoEditor = object(TApplication)
    Heap:PHeapView;
    constructor Init;
    destructor Done;virtual;
    procedure Idle;virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure InitMenuBar; virtual;
    procedure InitStatusLine; virtual;
    procedure OutOfMemory; virtual;
    procedure FileOpen(FileName: FNameStr);
    procedure AppOptions;
  end;

constructor TDemoEditor.Init;
var R:TRect;
    i:integer;
    FileName: FNameStr;
begin
  InitVMM;
  inherited Init;
  GetExtent(R);
    Dec(R.B.X);
    R.A.X := R.B.X - 9; R.A.Y := R.B.Y - 1;
    Heap := New(PHeapView, Init(R));
    Insert(Heap);
  DisableCommands([cmSave, cmSaveAs, cmCut, cmCopy, cmPaste, cmClear,
    cmUndo, cmFind, cmReplace, cmSearchAgain]);
  InitStandartClipboard;
  for I := 1 to ParamCount do
  begin
    FileName := ParamStr(I);
    if FileName[Length(FileName)] = '\' then
      FileName := FileName + '*.*';
    if (Pos('?', FileName) = 0) and (Pos('*', FileName) = 0) then
    begin
      Desktop^.GetExtent(R);
      InsertWindow(New(PExtEditWindow, Init(R,FileName,GetWindowNumber)));
    end
    else FileOpen(FileName);
  end;
end;

destructor TDemoEditor.Done;
begin
  inherited Done;
  DoneVMM;
end;

procedure TDemoEditor.Idle;
function IsTileable(P: PView): Boolean; far;
begin
  IsTileable := (P^.Options and ofTileable <> 0) and
    (P^.State and sfVisible <> 0);
end;
begin
  inherited Idle;
  Heap^.Update;
{  if Desktop^.FirstThat(@IsTileable) <> nil then
    EnableCommands([cmTile, cmCascade])
  else
    DisableCommands([cmTile, cmCascade]);}
end;

procedure TDemoEditor.FileOpen(FileName: FNameStr);
var
  R:TRect;
begin
  if ExecuteDialog(New(PFileDialog, Init('*.*', 'Open file',
    '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then
  begin
    Desktop^.GetExtent(R);
    InsertWindow(New(PExtEditWindow, Init(R,FileName,GetWindowNumber)));
  end;
end;

procedure TDemoEditor.HandleEvent(var Event: TEvent);
procedure FileNew;
var
  R:TRect;
begin
  Desktop^.GetExtent(R);
  InsertWindow(New(PExtEditWindow, Init(R,'',GetWindowNumber)));
end;

procedure ChangeDir;
begin
  if ExecuteDialog(New(PChDirDialog, Init(cdNormal, 0)), nil)<>cmCancel then
  begin
     Message(Application, evBroadcast, cmUpdateTitle, nil);
     Redraw;
  end;
end;

procedure ShowClip;
begin
  if Clipboard<>nil then
  begin
    Clipboard^.Owner^.Show;
    Clipboard^.Owner^.Select;
    PWindow(Clipboard^.Owner)^.Number:=GetWindowNumber;
  end;
end;

procedure Calculator;
begin
  InsertWindow(New(PCalculator, Init));
end;
procedure DoClose(P:PView);far;
begin
  Message(P, evCommand, cmClose, nil);
end;
begin
  inherited HandleEvent(Event);
  case Event.What of
    evCommand:
      case Event.Command of
        cmOpen: FileOpen('*.txt');
        cmNew: FileNew;
        cmChangeDir: ChangeDir;
        cmCalculator: Calculator;
        cmWindowList: WindowListDlg;
        cmOptions:AppOptions;
        cmShowClip: ShowClip;
{        cmCloseAll:Desktop^.ForEach(@DoClose);}
      else
        Exit;
      end;
  else
    Exit;
  end;
  ClearEvent(Event);
end;

procedure TDemoEditor.InitMenuBar;
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu(strFile, hcNoContext, NewMenu(
      StdFileMenuItems(
      nil)),
    NewSubMenu(strEdit, hcNoContext, NewMenu(
      StdEditMenuItems(
      NewLine(
      NewItem('~S~how clipboard', '', kbNoKey, cmShowClip, hcNoContext,
      nil)))),
    NewSubMenu(strSearch, hcNoContext, NewMenu(
      NewItem('~F~ind...', '', kbNoKey, cmFind, hcNoContext,
      NewItem('~R~eplace...', '', kbNoKey, cmReplace, hcNoContext,
      NewItem('~S~earch again', '', kbNoKey, cmSearchAgain, hcNoContext,
      NewLine(
      NewItem('~G~o to line number...', '', kbNoKey, cmGotoLine, hcNoContext,
      nil)))))),
    NewSubMenu('~T~olls', hcNoContext, NewMenu(
      NewItem('Ca~l~culator', '', kbNoKey, cmCalculator, hcNoContext,
      NewLine(
      NewItem('~O~ptions', '', kbNoKey, cmOptions, hcNoContext,
      nil)))),
    NewSubMenu(strWindow, hcNoContext, NewMenu(
      StdWindowMenuItems(
      NewLine(
      NewItem('~L~ist...', 'Alt+0', kbAlt0, cmWindowList, hcNoContext,
      nil)))),
    nil))))))));
end;

procedure TDemoEditor.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
    NewStatusDef(0, $FFFF,
      NewStatusKey('~F2~ Save', kbF2, cmSave,
      NewStatusKey('~F3~ Open', kbF3, cmOpen,
      NewStatusKey('~Alt-F3~ Close', kbAltF3, cmClose,
      NewStatusKey('~F5~ Zoom', kbF5, cmZoom,
      NewStatusKey('~F6~ Next', kbF6, cmNext,
      NewStatusKey('~F10~ Menu', kbF10, cmMenu,
      NewStatusKey('', kbCtrlF5, cmResize,
      nil))))))),
    nil)));
end;

procedure TDemoEditor.OutOfMemory;
begin
  MessageBox(strNotMem, nil, mfError + mfOkButton);
end;

procedure TDemoEditor.AppOptions;
var Rec:TStdEditorOptionsRec;
begin
  FillChar(Rec, SizeOf(TStdEditorOptionsRec), 0);
  Rec.EditorFlags:=EditorFlags;
  Rec.TabSize:=TabSize;
  if ExecuteDialog(StdEditorOptionsDlg, @Rec)<>cmCancel then
  begin
    EditorFlags:=Rec.EditorFlags;
    TabSize:=Rec.TabSize;
  end;
end;

var
  DemoEditor:TDemoEditor;
begin
  DemoEditor.Init;
  DemoEditor.Run;
  DemoEditor.Done;
end.