program DiskInfo;
uses Windows, Strings{, ODialogs};

{$R DiskInfo.res}

const
  IDD_DISKINFO            = 1;
  IDC_LOGDRIVES           = 100;
  IDC_DRIVETYPE           = 101;
  IDC_VOLINFO             = 102;
  IDC_DISKINFO            = 103;

function ComboBox_AddString(hwndCtl:HWND; P:PChar):integer;inline;
begin
  Result:=SendMessage(hwndCtl, cb_AddString, 0, Integer(P));
end;

function ComboBox_GetLBText(hwndCtl:HWND; Index:integer; P:PChar):integer;inline;
begin
  Result:=Integer(SendMessage(hwndCtl, cb_GetLBText, Index, LongInt(P)));
end;

function ComboBox_SetCurSelect(hwndCtl:HWND; Index:integer):integer;inline;
begin
  Result:=Integer(SendMessage(hwndCtl, CB_SETCURSEL, Index, 0));
end;

function IntToStr(A:integer):string;
begin
  Str(A, Result);
end;

procedure DlgFillDriveInfo(wnd:HWND; lpszRootPathName:LPTSTR);
var
  nDriveType : integer;
  P : LPCTSTR;
  lpVolumeNameBuffer : array[0..200] of TChar;
  dwVolumeSerialNumber, dwMaximumComponentLength : DWORD;
  dwFileSystemFlags : DWORD;
  dwSectorPerCluster, dwBytesPerSector, dwFreeClusters, dwClusters : DWORD;
  lpFileSystemNameBuffer : array [0..50] of char;
  S:string;
begin
  nDriveType:=GetDriveType(lpszRootPathName);
  case nDriveType of
    0               : P:='Cannot be determined.';
    1               : P:='Path does not exist.';
    DRIVE_REMOVABLE : P:='Removable';
    DRIVE_FIXED     : P:='Fixed';
    DRIVE_REMOTE    : P:='Remote';
    DRIVE_CDROM     : P:='CD-ROM';
    DRIVE_RAMDISK   : P:='RAM Disk';
  else
    P:='Unknow';
  end;
  SetWindowText(GetDlgItem(Wnd, IDC_DRIVETYPE),P);
  //砥 䭮ଠ  ⮬
  if GetVolumeInformation(lpszRootPathName, lpVolumeNameBuffer,
       SizeOf(lpVolumeNameBuffer), @dwVolumeSerialNumber,
       dwMaximumComponentLength, dwFileSystemFlags,
       lpFileSystemNameBuffer, SizeOf(lpFileSystemNameBuffer)) then
  begin
    S:=StrPas(lpVolumeNameBuffer)+#10+IntToStr(dwVolumeSerialNumber)+#10+
       IntToStr(dwMaximumComponentLength)+#10;
    if dwFileSystemFlags and FS_CASE_IS_PRESERVED <> 0 then
       S:=S+'FS_CASE_IS_PRESERVED';
    S:=S+#10;
    if dwFileSystemFlags and FS_CASE_SENSITIVE <> 0 then
       S:=S+'FS_CASE_SENSITIVE';
    S:=S+#10;
    if dwFileSystemFlags and FS_UNICODE_STORED_ON_DISK <> 0 then
       S:=S+'FS_UNICODE_STORED_ON_DISK';
    S:=S+#10;
    if dwFileSystemFlags and FS_PERSISTENT_ACLS <> 0 then
       S:=S+'FS_PERSISTENT_ACLS';
    S:=S+#10+StrPas(lpFileSystemNameBuffer)+#0;
  end
  else S:='NO VOLUME INFO'#0;
  SetWindowText(GetDlgItem(Wnd, IDC_VOLINFO),@S[1]);
  //砥 ଠ  ᪮ ࠭⢥
  if GetDiskFreeSpace(lpszRootPathName, dwSectorPerCluster,
     dwBytesPerSector, dwFreeClusters, dwClusters) then
  begin
    S:=IntToStr(dwSectorPerCluster)+#10+
       IntToStr(dwBytesPerSector)+#10+
       IntToStr(dwFreeClusters)+#10+
       IntToStr(dwClusters)+#0;
  end
  else S:='NO'#10'DISK'#10'SPACE'#10'INFO'#0;
  SetWindowText(GetDlgItem(Wnd, IDC_DISKINFO),@S[1]);
end;

function DlgOnInitDialog(Wnd:HWND; hWNDFocus:HWND; lParams:LPARAM):boolean;
var
  dwNumBytesForDriveStrings : DWORD;
  LP, LP1:PChar;
  hwndCtl : HWND;
  nNumDrives, nDriveNum:integer;
  szLogDrive:array[0..100] of Char;
begin
  nNumDrives:=0;
  SetClassLong(wnd, GCL_HICON, Long(LoadIcon(GetWindowLong(Wnd, GWL_HINSTANCE), 'DISKINFO')));
  dwNumBytesForDriveStrings:=GetLogicalDriveStrings(0, nil);
  hwndCtl:=GetDlgItem(Wnd, IDC_LOGDRIVES);
  if dwNumBytesForDriveStrings<>0 then
  begin
    //Windows NT
    GetMem(LP, dwNumBytesForDriveStrings);
    LP1:=LP;
    GetLogicalDriveStrings(dwNumBytesForDriveStrings, LP);
    while LP1^<>#0 do
    begin
      ComboBox_AddString(hwndCtl, LP1);
      while LP1^<>#0 do inc(LP1);
      inc(LP1);
      inc(nNumDrives);
    end;
    FreeMem(LP, dwNumBytesForDriveStrings);
  end
  else
  begin
     //other WIN32 systems
  end;

  nDriveNum:=0;
  while nDriveNum<nNumDrives do
  begin
    ComboBox_GetLBText(hwndCtl, nDriveNum, szLogDrive);
    if GetDriveType(szLogDrive)=DRIVE_FIXED then break;
    inc(nDriveNum);
  end;
  ComboBox_SetCurSelect(hwndCtl, nDriveNum);
  DlgFillDriveInfo(Wnd, szLogDrive);
end;

function DlgCommand(Wnd:HWND; ID:int; WndCtl:HWND; CodeNotify:UINT):boolean;
var
  szLogDrive:array[0..100] of Char;
begin
  Result:=true;
  case id of
    IDC_LOGDRIVES:
            begin
              if CodeNotify = CBN_SELCHANGE then exit;
              GetWindowText(WndCtl, szLogDrive, SizeOf(szLogDrive)-1);
              DlgFillDriveInfo(wnd, szLogDrive);
            end;
    IDCANCEL:EndDialog(Wnd, id);
  else
    Result:=false;
  end;
end;

function DlgProc(hDlg:HWND; uMsg:UINT; wParams:WPARAM; lParams:LPARAM):BOOL;stdcall;
begin
  case uMsg of
    WM_INITDIALOG:Result:=DlgOnInitDialog(hDlg, HWND(wParams), lParams);
    WM_COMMAND:Result:=DlgCommand(hDLg, LoWord(wParams), HWND(lParams), HiWord(wParams));
  else
    Result:=false;
  end;
end;

begin
  DialogBox(HInstance, PChar(IDD_DISKINFO), 0, @DlgProc);
end.
