uses Windows;

{$R sysinfo.RES}

const
  IDD_SYSINFO          = 1;
  IDC_OEMID            = 100;
  IDC_PAGESIZE         = 101;
  IDC_MINAPPADDR       = 102;
  IDC_MAXAPPADDR       = 103;
  IDC_ACTIVEPROCMASK   = 104;
  IDC_NUMOFPROC        = 105;
  IDC_PROCTYPE         = 106;
  IDC_ALLOCGRAN        = 107;

type
  ProcTypeItem = record
    ProcType:DWORD;
    ProcName:PChar;
  end;
{const
  ProcTypeItem}

function BigNumToString(lNum:Long; szBuf:PChar):PChar;
var S,S1:string;
    I:integer;
begin
  Str(lNum,S1);
  S:='';
  for i:=Length(S1) downto 1 do
  begin
    if ((Length(s1)-i) mod 3 = 0) and (i<>Length(s1)) then S:=','+S;
    S:=S1[i]+S;
  end;
  if S[1]=',' then Delete(S,1,1);
  move(S[1],szBuf^, Length(S));
  szBuf[Length(S)]:=#0;
  Result:=szBuf;
end;

function DlgCommand(Wnd:HWND; ID:int; WndCtl:HWND; CodeNotify:UINT):boolean;
begin
  if id=IDCANCEL then EndDialog(Wnd, id);
  Result:=true;
end;

function DlgOnInitDialog(Wnd:HWND; hWNDFocus:HWND; lParams:LPARAM):boolean;
var
  SI:TSystemInfo;
  szBuf:array [0..50] of char;
begin
  SetClassLong(wnd, GCL_HICON, Long(LoadIcon(GetWindowLong(Wnd, GWL_HINSTANCE), 'SYSINFO')));
  GetSystemInfo(SI);
  SetDlgItemText(wnd, IDC_OEMID, BigNumToString(SI.dwOemID, szBuf));
  SetDlgItemText(wnd, IDC_PAGESIZE, BigNumToString(SI.dwPageSize, szBuf));
  SetDlgItemText(wnd, IDC_MINAPPADDR, BigNumToString(Longint(SI.lpMinimumApplicationAddress), szBuf));
  SetDlgItemText(wnd, IDC_MAXAPPADDR, BigNumToString(Longint(SI.lpMaximumApplicationAddress), szBuf));
  SetDlgItemText(wnd, IDC_ACTIVEPROCMASK, BigNumToString(SI.dwActiveProcessorMask, szBuf));
  SetDlgItemText(wnd, IDC_NUMOFPROC, BigNumToString(SI.dwNumberOfProcessors, szBuf));
  SetDlgItemText(wnd, IDC_PROCTYPE, BigNumToString(SI.dwProcessorType, szBuf));
  SetDlgItemText(wnd, IDC_ALLOCGRAN, BigNumToString(SI.dwAllocationGranularity, szBuf));
  Result:=true;
end;

function DlgProc(hDlg:HWND; uMsg:UINT; wParams:WPARAM; lParams:LPARAM):BOOL;stdcall;
begin
  case uMsg of
    WM_INITDIALOG:Result:=DlgOnInitDialog(hDlg, HWND(wParams), lParams);
    WM_COMMAND:Result:=DlgCommand(hDLg, LoWord(wParams), HWND(lParams), HiWord(wParams));
  else
    Result:=false;
  end;
end;

begin
  DialogBox(HInstance, PChar(IDD_SYSINFO), 0, @DlgProc);
end.
