unit Std_Str;
interface
const
    { Common Picture Validator Integer Formats }
  PicIntUnsigned = '#[#][#]*{[;,]###}';    { unsigned int, optional commas }
  PicIntUnsignedComma = '#[#][#]*{;,###}'; { unsigned int with commas }
  PicIntSigned  = '[-]#[#][#]*{[;,]###}';  { signed int, optional commas }
  PicIntSignedComma = '[-]#[#][#]*{;,###}';{ signed int with commas }

    { Common Picture Validator Real Formats }
  picReal      = '[-]#[*#][[.]#[*#]][E[-]#[#]]';  { full capabilities }
  PicReal1 = '*#[{;,###}][.*#]';     { real, optional commas and decimal }
  PicReal2 = '#[#][#]*{;,###}[.*#]'; { real with commas, optional decimal }
  PicReal3 = '#[#][#]*{;,###}.[*#]'; { real with commas and at least a
                                       decimal point }
    { Common Picture Validator Stringl Formats }
  PicString1 = '*? ';          { accept only letters }
  PicString2 = '*& ';          { convert all letters to uppercase }
  PicFirstCharUp = '*{&*? }'; { uppercase the first char of every word }

    { Common Picture Validator Money Formats }
  PicMoney  = '$*#.##';
  PicMoney1 = '[$]*#[.[#][#]]'; { dollars, optional dollar sign and decimal }
  PicMoney2 = '[$]*#[.[#][#]]'; { dollars with comma, optional dollar sign }
  PicMoney3 = '$*#{;,###}[.[#][#]]';  { dollars, with comma and dollar sign }
     { dollars, optional dollar sign, commas and 0, 1 or 2 decimal places }
  PicMoney4 = '[$]*#[{;,###}][.[#][#]]';

    { Common Picture Validator Date Formats }
  PicDate1 = '#[#]/#[#]/##';     { date with 2 digit year last }
  PicDate2 = '#[#]/#[#]/##[##]'; { date with 2 or 4 digit year last }
  PicDate3 = '#[#]/#[#]/####';   { date with 4 digit year (mm/dd/yyyy) }
     { a date in the format "JAN 31, 1999" with auto fill-in }
  PicDate4 = '{J{AN ,U{N ,L }},FEB ,MA{R ,Y },A{PR ,UG },SEP ,OCT ,NOV' +
             ',DEC} {1[#],2[#],30,31,#};, 19##';

    { Common Picture Validator Time Formats }
  PicTime1 = '{##}:{##}[:{##}]'; { HH:MM:SS, optional seconds }
  PicTime2 = '{##}:{##}:{##}';   { HH:MM:SS }

    { Common Picture Validator Phone Formats }
  PicPhoneUS1 = '[(*3{#})]*3{#}-*4{#}'; { phone number, optional area code }
  PicPhoneUS2 = '(*3{#})*3{#}-*4{#}';   { phone number with area code }

     { FileName pictures for *.3 file name only; no path information }
  PicFilename1 = '{&*7[&]}.{*3[&]}'; { filename (no path) with extension }
  picFileName2  = '{&[&][&][&][&][&][&][&]}.{[&][&][&]}'; { forces uppercase }

    { Miscellaneous Picture Validator Formats }
  PicSSN = '###-##-####'; { US Social Security Number }
     { colors with autofill }
  PicColor = '{Red,Gr{ay,een},B{l{ack,ue},rown},White,Yellow}';
  {客  ᨮ 䮭 }
  StrahPens = '###-###-### ##';
const
  sEol = #13#10; {Dos like end of line}
const
  {$IFDEF RUS} strHelp = '~~';
  {$ELSE}      strHelp = '~H~elp'; {$ENDIF RUS}
               strOk   = '~O~k';
  {$IFDEF RUS} strCancel = '⬥';
  {$ELSE}      strCancel = 'Cancel';{$ENDIF RUS}
  {$IFDEF RUS} strDelete        = '~D~elete';
  {$ELSE}      strDelete        = '~~';{$ENDIF RUS}
  {$IFDEF RUS} strYes           = '~Y~es';
  {$ELSE}      strYes           = '~~';{$ENDIF RUS}
  {$IFDEF RUS} strNo            = '~N~o';
  {$ELSE}      strNo            = '~~';{$ENDIF RUS}
  {$IFDEF RUS} strWarning       = 'Warning';
  {$ELSE}      strWarning       = '।०';{$ENDIF RUS}
  {$IFDEF RUS} strError         = 'Error';
  {$ELSE}      strError         = '訡';{$ENDIF RUS}
  {$IFDEF RUS} strInformation   = 'Information';
  {$ELSE}      strInformation   = 'ଠ';{$ENDIF RUS}
  {$IFDEF RUS} strConfirmation  = 'Confirmation';
  {$ELSE}      strConfirmation  = '⢥ত';{$ENDIF RUS}
  {$IFDEF RUS} strDirectory        = 'Directory';
  {$ELSE}      strDirectory        = '⠫';{$ENDIF RUS}
  {$IFDEF RUS} strFiles            = '~F~iles';
  {$ELSE}      strFiles            = '~~';{$ENDIF RUS}
  {$IFDEF RUS} strOpen1            = '~O~pen';
  {$ELSE}      strOpen1            = '~~';{$ENDIF RUS}

  {$IFDEF RUS} strReplace          = '~~';
  {$ELSE}      strReplace          = '~R~eplace';{$ENDIF RUS}

  {$IFDEF RUS} strInvalidCharacter = 'Invalid character in input';
  {$ELSE}      strInvalidCharacter = '  ᨬ';{$ENDIF RUS}
  {$IFDEF RUS} strInvalidPicture   = 'Input does not conform to picture: %s';
  {$ELSE}      strInvalidPicture   = 'Input does not conform to picture: %s';{$ENDIF RUS}
  {$IFDEF RUS} strInvalidValue     = 'Value not in the range %d to %d';
  {$ELSE}      strInvalidValue     = 'Input does not conform to picture: %s';{$ENDIF RUS}
  {$IFDEF RUS} strInvalidFValue    = 'Value not in the range %s to %s';
  {$ELSE}      strInvalidFValue    = 'Input does not conform to picture: %s';{$ENDIF RUS}
  {$IFDEF RUS} strNotInList        = 'Input  not in valid-list';
  {$ELSE}      strNotInList        = '祭   ⨬ ᯨ᪥';{$ENDIF RUS}
  {$IFDEF RUS} strNotInListParam   = 'Input ''%s'' not in valid-list';
  {$ELSE}      strNotInListParam   = '祭 ''%s''   ⨬ ᯨ᪥';{$ENDIF RUS}
  {$IFDEF RUS} strInvalidAdres     = 'Invalid Addres value. Format is ''xxxx:yyyy''.';
  {$ELSE}      strInvalidAdres     = '祭 ''%s''   ⨬ ᯨ᪥';{$ENDIF RUS}
  {$IFDEF RUS} strTooManyFiles     = 'Too many files.';
  {$ELSE}      strTooManyFiles     = '誮  䠩.';{$ENDIF RUS}
  {$IFDEF RUS} strInvalidDrive     = 'Invalid drive or directory.';
  {$ELSE}      strInvalidDrive     = '୮  ᪠  ⠫.';{$ENDIF RUS}
  {$IFDEF RUS} strInvalidFileName  = 'Invalid file name.';
  {$ELSE}      strInvalidFileName  = '訡   䠩.';{$ENDIF RUS}
  {$IFDEF RUS} strDrives           = 'Drives';
  {$ELSE}      strDrives           = 'ன⢠';{$ENDIF RUS}
  {$IFDEF RUS} strDataError        = 'Error %s.';
  {$ELSE}      strDataError        = '訡 %s.';{$ENDIF RUS}
  {$IFDEF RUS} strSaveModify       = '%s has been modified. Save?';
  {$ELSE}      strSaveModify       = '%s  . ࠭?';{$ENDIF RUS}
  {$IFDEF RUS} strSaveUntitled     = 'Save untitled file?';
  {$ELSE}      strSaveUntitled     = '࠭ ﭭ 䠩?';{$ENDIF RUS}
  {$IFDEF RUS} strErrorCreateFile  = '訡 ᮧ 䠩 %s.';
  {$ELSE}      strErrorCreateFile  = 'Error creating file %s.';{$ENDIF RUS}
  {$IFDEF RUS} strNotFoundString   = '᪮ ப  ';
  {$ELSE}      strNotFoundString   = 'Search string not found.';{$ENDIF RUS}
  {$IFDEF RUS} strFileExists       = 'File %s already exists. Overwrite?';
  {$ELSE}      strFileExists       = ' %s 㦥 . ९?';{$ENDIF RUS}
  {$IFDEF RUS} strPrinterNotReady  = 'Printer not ready. Continue?';
  {$ELSE}      strPrinterNotReady  = ' %s 㦥 . ९?';{$ENDIF RUS}
  {$IFDEF RUS} strPrinterNewPage   = '⠢    த';
  {$ELSE}      strPrinterNewPage   = ' %s 㦥 . ९?';{$ENDIF RUS}
  {$IFDEF RUS} strNotMem           = 'Not enough memory for this operation.';
  {$ELSE}      strNotMem           = '墠⠥   믮 ⮩ 樨.';{$ENDIF RUS}
  {$IFDEF RUS} strUntitled         = 'Untitled';
  {$ELSE}      strUntitled         = ' ';{$ENDIF RUS}
  {$IFDEF RUS} strFile             = '~F~ile';
  {$ELSE}      strFile             = '~~';{$ENDIF RUS}
  {$IFDEF RUS} strNew              = '~N~ew';
  {$ELSE}      strNew              = '~~';{$ENDIF RUS}
  {$IFDEF RUS} strOpen             = '~O~pen...';
  {$ELSE}      strOpen             = '~~...';{$ENDIF RUS}
  {$IFDEF RUS} strSaveAll          = 'Save a~l~l';
  {$ELSE}      strSaveAll          = '࠭ ~~';{$ENDIF RUS}
  {$IFDEF RUS} strExit             = 'E~x~it';
  {$ELSE}      strExit             = '~~';{$ENDIF RUS}
  {$IFDEF RUS} strEdit             = '~E~dit';
  {$ELSE}      strEdit             = '~~ࠢ';{$ENDIF RUS}
  {$IFDEF RUS} strUndo             = '~U~ndo';
  {$ELSE}      strUndo             = '~~';{$ENDIF RUS}
  {$IFDEF RUS} strCut              = 'Cu~t~';
  {$ELSE}      strCut              = '~~१';{$ENDIF RUS}
  {$IFDEF RUS} strCopy             = '~C~opy';
  {$ELSE}      strCopy             = '~~஢';{$ENDIF RUS}
  {$IFDEF RUS} strPaste            = '~P~aste';
  {$ELSE}      strPaste            = '~~⠢';{$ENDIF RUS}
  {$IFDEF RUS} strClear            = 'C~l~ear';
  {$ELSE}      strClear            = '~~';{$ENDIF RUS}
  {$IFDEF RUS} strShowClp          = '~S~how clipboard';
  {$ELSE}      strShowClp          = '~~ ';{$ENDIF RUS}
  {$IFDEF RUS} strSearch           = '~S~earch';
  {$ELSE}      strSearch           = '~~';{$ENDIF RUS}
  {$IFDEF RUS} strWindow           = '~W~indows';
  {$ELSE}      strWindow           = '~~';{$ENDIF RUS}
  {$IFDEF RUS} strNext             = '~N~ext';
  {$ELSE}      strNext             = '~~饥';{$ENDIF RUS}
  {$IFDEF RUS} strClose            = '~C~lose';
  {$ELSE}      strClose            = '~~';{$ENDIF RUS}
  {$IFDEF RUS} strEditOptions      = '樨 ।';
  {$ELSE}      strEditOptions      = 'Editor options';{$ENDIF RUS}
  {$IFDEF RUS} strChangeAll        = ' ~~';
  {$ELSE}      strChangeAll        = 'Change ~~ll';{$ENDIF}
  {$IFDEF RUS} strGoToLineNumber   = '  ப ...';
  {$ELSE}      strGoToLineNumber   = 'Go to Line Number...';{$ENDIF}
  {$IFDEF RUS} strEnterLineNumber  = '~~  ப';
  {$ELSE}      strEnterLineNumber  = '~E~nter new line number';{$ENDIF}
  {$IFDEF RUS} strCreateBackup     = ' ';
  {$ELSE}      strCreateBackup     = 'Create backup ~f~iles';{$ENDIF}
  {$IFDEF RUS} strInsertMode       = ' ⠢';
  {$ELSE}      strInsertMode       = '~I~nsert mode';{$ENDIF}
  {$IFDEF RUS} strAutoIndent       = '⮮';
  {$ELSE}      strAutoIndent       = '~A~uto indent mode';{$ENDIF}
  {$IFDEF RUS} strUseTabChars      = 'ᯮ짮 TAB';
  {$ELSE}      strUseTabChars      = '~U~se tab characters';{$ENDIF}



implementation
end.
